
    org 0000H
    incl '1802reg.asm'

    org 0000H
;
    dis            ; Disable. Return from interrupt, set IE=0
    idl            ; Idle or wait for interrupt or DMA request
    ghi r0         ; Get high register R0
    phi r3         ; Put high register R3
    ldi 08         ; Load D immediate
    plo r3         ; Put low register R3
    sep r3         ; Set P=R3 as program counter
;;
    sex r3         ; Set P=R3 as datapointer
    dis            ; Disable. Return from interrupt, set IE=0
    dec r3         ; Decrement (R3)
    ldi $0f         ; Load D immediate
    phi r9         ; Put high register R9
    ldi $ff         ; Load D immediate
    plo r9         ; Put low register R9
;;
    sex r3         ; Set P=R3 as datapointer
    dis            ; Disable. Return from interrupt, set IE=0
    plo r3         ; Put low register R3
    ghi r9         ; Get high register R9
    phi ra         ; Put high register RA
    glo r9         ; Get low register R9
    plo ra         ; Put low register RA
    ldx            ; Pop stack. Place value in D register
    plo r8         ; Put low register R8
    dec ra         ; Decrement (RA)
    ldx            ; Pop stack. Place value in D register
    phi r8         ; Put high register R8
    dec ra         ; Decrement (RA)
    glo r8         ; Get low register R8
    sm             ; Substract memory: DF,D=D-(R(X))
    plo rb         ; Put low register RB
    dec ra         ; Decrement (RA)
    ghi r8         ; Get high register R8
    smb            ; Substract memory with borrow
    phi rb         ; Put high register RB
    dec ra         ; Decrement (RA)
    glo r8         ; Get low register R8
    sm             ; Substract memory: DF,D=D-(R(X))
    plo r4         ; Put low register R4
    plo r5         ; Put low register R5
    dec ra         ; Decrement (RA)
    ghi r8         ; Get high register R8
    smb            ; Substract memory with borrow
    phi r4         ; Put high register R4
    phi r5         ; Put high register R5
    ldi $00         ; Load D immediate
    phi r6         ; Put high register R6
    plo r6         ; Put low register R6
    sex r8         ; Set P=R8 as datapointer
;;
    ldn r8         ; Load D with (R8)
    plo r7         ; Put low register R7
    xri $ff         ; Logical XOR D with value
    str r8         ; Store D to (R8)
    xor            ; Logical exclusive OR  D with (R(X))
    bz  $42         ; Short branch on D=0
    bdf  $4a        ; Short branch on DF=1
    glo r7         ; Get low register R7
    str r8         ; Store D to (R8)
    br  $55         ; Short branch
;;
    inc r6         ; Increment (R6)
    bnf $4a        ; Short branch on DF=0
    shl            ; Shift left D
    ghi r8         ; Get high register R8
    phi r9         ; Put high register R9
    glo r8         ; Get low register R8
    plo r9         ; Put low register R9
    glo r7         ; Get low register R7
    stxd           ; Store via X and devrement
    glo rb         ; Get low register RB
    bnz  $50        ; Short branch on D!=0
    ghi rb         ; Get high register RB
    dec rb         ; Decrement (RB)
    bnz  $34        ; Short branch on D!=0
    bdf  $8c        ; Short branch on DF=1
;;
    irx            ; Increment register X
    ldn r9         ; Load D with (R9)
    plo r7         ; Put low register R7
    sex r9         ; Set P=R9 as datapointer
    inc ra         ; Increment (RA)
    inc ra         ; Increment (RA)
    inc ra         ; Increment (RA)
    inc ra         ; Increment (RA)
    inc ra         ; Increment (RA)
    glo ra         ; Get low register RA
    str r9         ; Store D to (R9)
    glo r9         ; Get low register R9
    sm             ; Substract memory: DF,D=D-(R(X))
    ghi ra         ; Get high register RA
    str r9         ; Store D to (R9)
    ghi r9         ; Get high register R9
    smb            ; Substract memory with borrow
    glo r7         ; Get low register R7
    str r9         ; Store D to (R9)
;;
    ldn ra         ; Load D with (RA)
    dec ra         ; Decrement (RA)
    lsnf           ; Long skip on DF=0
    str r9         ; Store D to (R9)
    dec r6         ; Decrement (R6)
    dec r9         ; Decrement (R9)
    dec r4         ; Decrement (R4)
    ghi r4         ; Get high register R4
    bnz  $68        ; Short branch on D!=0
    glo r4         ; Get low register R4
    bnz  $68        ; Short branch on D!=0
    ghi r9         ; Get high register R9
    phi r2         ; Put high register R2
    glo r9         ; Get low register R9
    plo r2         ; Put low register R2
    lda ra         ; Load D from (RA), increment RA
    lsdf           ; Long skip on DF=1
    str r9         ; Store D to (R9)
    dec r6         ; Decrement (R6)
    inc r9         ; Increment (R9)
    dec r5         ; Decrement (R5)
    ghi r5         ; Get high register R5
    bnz $79        ; Short branch on D!=0
    glo r5         ; Get low register R5
    bnz $79        ; Short branch on D!=0
;;
    glo r6         ; Get low register R6
    smi $0a         ; Substract D,DF to value
    ghi r6         ; Get high register R6
    smbi 00          ; Substract memory toh borrow, immediate
    lsdf           ; Long skip on DF=1
    seq            ; Set Q=1
    dec r3         ; Decrement (R3)
;;
    glo r9         ; Get low register R9
    smi $17         ; Substract D,DF to value
    plo ra         ; Put low register RA
    ghi r9         ; Get high register R9
    smbi 00h          ; Substract memory toh borrow, immediate
    phi ra         ; Put high register RA
    glo r9         ; Get low register R9
    smi $7e         ; Substract D,DF to value
    plo rb         ; Put low register RB
    ghi r9         ; Get high register R9
    smbi 00h           ; Substract memory toh borrow, immediate
    phi rb         ; Put high register RB
    str ra         ; Store D to (RA)
    inc ra         ; Increment (RA)
    glo rb         ; Get low register RB
    str ra         ; Store D to (RA)
    inc rb         ; Increment (RB)
    inc rb         ; Increment (RB)
    inc ra         ; Increment (RA)
    ghi rb         ; Get high register RB
    str ra         ; Store D to (RA)
    inc ra         ; Increment (RA)
    glo rb         ; Get low register RB
    str ra         ; Store D to (RA)
    inc rb         ; Increment (RB)
    glo rb         ; Get low register RB
    smi 08         ; Substract D,DF to value
    str rb         ; Store D to (RB)
    dec rb         ; Decrement (RB)
    ghi rb         ; Get high register RB
    smbi  00         ; Substract memory toh borrow, immediate
    str rb         ; Store D to (RB)
    ghi r9         ; Get high register R9
    phi ra         ; Put high register RA
    glo r9         ; Get low register R9
    plo ra         ; Put low register RA
    sex ra         ; Set P=RA as datapointer
    stxd           ; Store via X and devrement
    ghi r9         ; Get high register R9
    stxd           ; Store via X and devrement
    glo r8         ; Get low register R8
    stxd           ; Store via X and devrement
    ghi r8         ; Get high register R8
    stxd           ; Store via X and devrement
    glo r2         ; Get low register R2
    stxd           ; Store via X and devrement
    ghi r2         ; Get high register R2
    stxd           ; Store via X and devrement
    glo r8         ; Get low register R8
    stxd           ; Store via X and devrement
    ghi r8         ; Get high register R8
    stxd           ; Store via X and devrement
;;
    ldi $09         ; Load D immediate
    dec ra         ; Decrement (RA)
    smi $01         ; Substract D,DF to value
    bnz  $ca        ; Short branch on D!=0
    ldxa           ; Load via X and advance
    phi r8         ; Put high register R8
    ldxa           ; Load via X and advance
    plo r8         ; Put low register R8
    ldxa           ; Load via X and advance
    phi r1         ; Put high register R1
    ldxa           ; Load via X and advance
    plo r1         ; Put low register R1
    ldxa           ; Load via X and advance
    phi r4         ; Put high register R4
    ldxa           ; Load via X and advance
    plo r4         ; Put low register R4
    ldxa           ; Load via X and advance
    phi r5         ; Put high register R5
    ldxa           ; Load via X and advance
    plo r5         ; Put low register R5
    lbr $010e       ; Long branch
;;
    phi r3         ; Put high register R3
    lda r7         ; Load D from (R7), increment R7
    plo r3         ; Put low register R3
    sep r3         ; Set P=R3 as program counter
    lda r7         ; Load D from (R7), increment R7
    bnz  $e2        ; Short branch on D!=0
    lda r7         ; Load D from (R7), increment R7
    stxd           ; Store via X and devrement
    br  $e6         ; Short branch
    sep r5         ; Set P=R5 as program counter
;;
    ghi r7         ; Get high register R7
    str r6         ; Store D to (R6)
    inc r6         ; Increment (R6)
    glo r7         ; Get low register R7
    str r6         ; Store D to (R6)
    inc r6         ; Increment (R6)
    glo r3         ; Get low register R3
    plo r7         ; Put low register R7
    ghi r3         ; Get high register R3
    phi r7         ; Put high register R7
    br  $ed         ; Short branch
;;
    ret            ; Return from interrupt, set IE=1
    dec r2         ; Decrement (R2)
    str r2         ; Store D to (R2)
    dec rc         ; Decrement (RC)
    ldi $e9         ; Load D immediate
                   ;<<< note no "idl" instruction
    plo r0         ; Put low register R0
    out 1          ; Output (R(X)); Increment R(X), N=001
    dec r2         ; Decrement (R2)
    ldx            ; Pop stack. Place value in D register
    sav            ; Save
    lbr $00fa       ; Long branch
clear:
    lbr $0008       ; Long branch
reset:
    lbr $0011       ; Long branch
abort:
    sex r3         ; Set P=R3 as datapointer
    dis            ; Disable. Return from interrupt, set IE=0
    dec r3         ; Decrement (R3)
    ghi r3         ; Get high register R3
    phi rb         ; Put high register RB
    glo r3         ; Get low register R3
    plo rb         ; Put low register RB
    inc rb         ; Increment (RB)
    sep rb         ; Set P=RB as program counter
    glo r9         ; Get low register R9
    smi $09         ; Substract D,DF to value
    plo ra         ; Put low register RA
    ghi r9         ; Get high register R9
    smbi 00          ; Substract memory toh borrow, immediate
    phi ra         ; Put high register RA
    lda ra         ; Load D from (RA), increment RA
    phi r3         ; Put high register R3
    lda ra         ; Load D from (RA), increment RA
    plo r3         ; Put low register R3
    lda ra         ; Load D from (RA), increment RA
    phi r6         ; Put high register R6
    lda ra         ; Load D from (RA), increment RA
    plo r6         ; Put low register R6
    lda ra         ; Load D from (RA), increment RA
    phi r2         ; Put high register R2
    lda ra         ; Load D from (RA), increment RA
    plo r2         ; Put low register R2
    sep r3         ; Set P=R3 as program counter
return:
    dec r6         ; Decrement (R6)
    ldn r6         ; Load D with (R6)
    plo r7         ; Put low register R7
    dec r6         ; Decrement (R6)
    ldn r6         ; Load D with (R6)
    phi r7         ; Put high register R7
    sep r5         ; Set P=R5 as program counter
dup:
    irx            ; Increment register X
    ldx            ; Pop stack. Place value in D register
    stxd           ; Store via X and devrement
    stxd           ; Store via X and devrement
    sep r5         ; Set P=R5 as program counter
ddrop:
    irx            ; Increment register X
    irx            ; Increment register X
    sep r5         ; Set P=R5 as program counter
drop:
    irx            ; Increment register X
    sep r5         ; Set P=R5 as program counter
over:
    ghi r2         ; Get high register R2
    phi ra         ; Put high register RA
    glo r2         ; Get low register R2
    plo ra         ; Put low register RA
    inc ra         ; Increment (RA)
    inc ra         ; Increment (RA)
    ldn ra         ; Load D with (RA)
    stxd           ; Store via X and devrement
    sep r5         ; Set P=R5 as program counter
swap:
    irx            ; Increment register X
    ldxa           ; Load via X and advance
    phi ra         ; Put high register RA
    ldx            ; Pop stack. Place value in D register
    plo ra         ; Put low register RA
    ghi ra         ; Get high register RA
    stxd           ; Store via X and devrement
    glo ra         ; Get low register RA
    stxd           ; Store via X and devrement
    sep r5         ; Set P=R5 as program counter
rot:
    irx            ; Increment register X
    ldxa           ; Load via X and advance
    phi ra         ; Put high register RA
    ldxa           ; Load via X and advance
    plo ra         ; Put low register RA
    ldx            ; Pop stack. Place value in D register
    phi rb         ; Put high register RB
    glo ra         ; Get low register RA
    stxd           ; Store via X and devrement
    ghi ra         ; Get high register RA
    stxd           ; Store via X and devrement
    ghi rb         ; Get high register RB
    stxd           ; Store via X and devrement
    sep r5         ; Set P=R5 as program counter
add:
    irx            ; Increment register X
    ldxa           ; Load via X and advance
    add            ; Add D: D,DF= D+(R(X))
    stxd           ; Store via X and devrement
    sep r5         ; Set P=R5 as program counter
subtr:
    irx            ; Increment register X
    ldxa           ; Load via X and advance
    sd             ; Substract D: D,DF=(R(X))-D
    stxd           ; Store via X and devrement
    sep r5         ; Set P=R5 as program counter
and1:
    irx            ; Increment register X
    ldxa           ; Load via X and advance
    and            ; Logical AND: D with (R(X))
    stxd           ; Store via X and devrement
    sep r5         ; Set P=R5 as program counter
or1:
    irx            ; Increment register X
    ldxa           ; Load via X and advance
    or             ; Logical OR  D with (R(X))
    stxd           ; Store via X and devrement
    sep r5         ; Set P=R5 as program counter
xor1:
    irx            ; Increment register X
    ldxa           ; Load via X and advance
    xor            ; Logical exclusive OR  D with (R(X))
    stxd           ; Store via X and devrement
    sep r5         ; Set P=R5 as program counter
not1:
    irx            ; Increment register X
    ldx            ; Pop stack. Place value in D register
    lsz            ; Long skip on D=0
    ldi $ff         ; Load D immediate
    xri $ff         ; Logical XOR D with value
    stxd           ; Store via X and devrement
    sep r5         ; Set P=R5 as program counter
equal:
    irx            ; Increment register X
    ldxa           ; Load via X and advance
    sd             ; Substract D: D,DF=(R(X))-D
    lsz            ; Long skip on D=0
    ldi $ff         ; Load D immediate
    xri $ff         ; Logical XOR D with value
    stxd           ; Store via X and devrement
    sep r5         ; Set P=R5 as program counter
greater:
    irx            ; Increment register X
    ldxa           ; Load via X and advance
    sm             ; Substract memory: DF,D=D-(R(X))
    ldi $ff         ; Load D immediate
    adci 00        ; Add with carry immediate
    stxd           ; Store via X and devrement
    sep r5         ; Set P=R5 as program counter
less:
    irx            ; Increment register X
    ldxa           ; Load via X and advance
    sd             ; Substract D: D,DF=(R(X))-D
    ldi $ff         ; Load D immediate
    adci $00        ; Add with carry immediate
    stxd           ; Store via X and devrement
    sep r5         ; Set P=R5 as program counter
    ghi r7         ; Get high register R7
    str r6         ; Store D to (R6)
    inc r6         ; Increment (R6)
    glo r7         ; Get low register R7
    str r6         ; Store D to (R6)
    inc r6         ; Increment (R6)
    sep r5         ; Set P=R5 as program counter
;;
    irx            ; Increment register X
    ldx            ; Pop stack. Place value in D register
    dec r6         ; Decrement (R6)
    lsz            ; Long skip on D=0
    dec r6         ; Decrement (R6)
    sep r5         ; Set P=R5 as program counter
    ldn r6         ; Load D with (R6)
    plo r7         ; Put low register R7
    dec r6         ; Decrement (R6)
    lda r6         ; Load D from (R6), increment R6
    phi r7         ; Put high register R7
    glo r7         ; Get low register R7
    str r6         ; Store D to (R6)
    inc r6         ; Increment (R6)
    sep r5         ; Set P=R5 as program counter
;;
    ghi r7         ; Get high register R7
    str r6         ; Store D to (R6)
    inc r6         ; Increment (R6)
    glo r7         ; Get low register R7
    str r6         ; Store D to (R6)
    inc r6         ; Increment (R6)
    irx            ; Increment register X
    ldxa           ; Load via X and advance
    plo ra         ; Put low register RA
    ldx            ; Pop stack. Place value in D register
    str r6         ; Store D to (R6)
    inc r6         ; Increment (R6)
    glo ra         ; Get low register RA
    str r6         ; Store D to (R6)
    inc r6         ; Increment (R6)
    sep r5         ; Set P=R5 as program counter
;;
    ldi 01         ; Load D immediate
    stxd           ; Store via X and devrement
    dec r6         ; Decrement (R6)
    ldn r6         ; Load D with (R6)
    irx            ; Increment register X
    add            ; Add D: D,DF= D+(R(X))
    dec r6         ; Decrement (R6)
    bdf  $e0        ; Short branch on DF=1
    str r2         ; Store D to (R2)
    ldn r6         ; Load D with (R6)
    sm             ; Substract memory: DF,D=D-(R(X))
    bnf  $e0        ; Short branch on DF=0
    glo r6         ; Get low register R6
    plo ra         ; Put low register RA
    ghi r6         ; Get high register R6
    phi ra         ; Put high register RA
    inc r6         ; Increment (R6)
    ldx            ; Pop stack. Place value in D register
    str r6         ; Store D to (R6)
    inc r6         ; Increment (R6)
    dec ra         ; Decrement (RA)
    ldn ra         ; Load D with (RA)
    plo r7         ; Put low register R7
    dec ra         ; Decrement (RA)
    ldn ra         ; Load D with (RA)
    phi r7         ; Put high register R7
    sep r5         ; Set P=R5 as program counter
    dec r6         ; Decrement (R6)
    dec r6         ; Decrement (R6)
    sep r5         ; Set P=R5 as program counter
i:
    dec r6         ; Decrement (R6)
    lda r6         ; Load D from (R6), increment R6
    stxd           ; Store via X and devrement
    sep r5         ; Set P=R5 as program counter
exit:
    glo r6         ; Get low register R6
    plo ra         ; Put low register RA
    ghi r6         ; Get high register R6
    phi ra         ; Put high register RA
    dec ra         ; Decrement (RA)
    dec ra         ; Decrement (RA)
    ldi 00         ; Load D immediate
    str ra         ; Store D to (RA)
    sep r5         ; Set P=R5 as program counter
br0:
    irx            ; Increment register X
    ldx            ; Pop stack. Place value in D register
    inc r7         ; Increment (R7)
    lsz            ; Long skip on D=0
    inc r7         ; Increment (R7)
    sep r5         ; Set P=R5 as program counter
    dec r7         ; Decrement (R7)
br:
    lda r7         ; Load D from (R7), increment R7
    str r2         ; Store D to (R2)
    ldn r7         ; Load D with (R7)
    plo r7         ; Put low register R7
    ldx            ; Pop stack. Place value in D register
    phi r7         ; Put high register R7
    sep r5         ; Set P=R5 as program counter
ie:
    irx            ; Increment register X
    ldx            ; Pop stack. Place value in D register
    sex r3         ; Set P=R3 as datapointer
    lsz            ; Long skip on D=0
    ret            ; Return from interrupt, set IE=1
    dec r3         ; Decrement (R3)
    lsnz           ; Long skip on D!=0
    dis            ; Disable. Return from interrupt, set IE=0
    dec r3         ; Decrement (R3)
    sep r5         ; Set P=R5 as program counter
ieat:
    ldi 01         ; Load D immediate
    lsie           ; Long skip on IE=1
    ldi 00         ; Load D immediate
    stxd           ; Store via X and devrement
    sep r5         ; Set P=R5 as program counter

    sep r5         ; Set P=R5 as program counter
varat:
    inc r3         ; Increment (R3)
    sex r3         ; Set P=R3 as datapointer
    glo r9         ; Get low register R9
    sm             ; Substract memory: DF,D=D-(R(X))
    str r2         ; Store D to (R2)
    dec r2         ; Decrement (R2)
    dec r3         ; Decrement (R3)
    ghi r9         ; Get high register R9
    smb            ; Substract memory with borrow
    sex r2         ; Set P=R2 as datapointer
    stxd           ; Store via X and devrement
    br  $10         ; Short branch
at:
    irx            ; Increment register X
    ldxa           ; Load via X and advance
    phi ra         ; Put high register RA
    ldx            ; Pop stack. Place value in D register
    plo ra         ; Put low register RA
    ldn ra         ; Load D with (RA)
    stxd           ; Store via X and devrement
    sep r5         ; Set P=R5 as program counter
excla:
    irx            ; Increment register X
    ldxa           ; Load via X and advance
    phi ra         ; Put high register RA
    ldxa           ; Load via X and advance
    plo ra         ; Put low register RA
    ldx            ; Pop stack. Place value in D register
    str ra         ; Store D to (RA)
    sep r5         ; Set P=R5 as program counter
emits: 	;Types out one byte on top of
    glo r9         ; Get low register R9
    smi $71         ; Substract D,DF to value
    plo ra         ; Put low register RA
    ghi r9         ; Get high register R9
    smbi 00          ; Substract memory toh borrow, immediate
    phi ra         ; Put high register RA
    ldn ra         ; Load D with (RA)
    str r6         ; Store D to (R6)
    nop            ; No operation
    smi 01         ; Substract D,DF to value
    bnz  $38        ; Short branch on D!=0
;;
    irx            ; Increment register X
    ldx            ; Pop stack. Place value in D register
    seq            ; Set Q=1
    plo rb         ; Put low register RB
    ldi $0a         ; Load D immediate
    plo ra         ; Put low register RA
;;
    ldn r6         ; Load D with (R6)
    phi rb         ; Put high register RB
    smi $01         ; Substract D,DF to value
    bdf  $46        ; Short branch on DF=1
    ghi rb         ; Get high register RB
    smi $23         ; Substract D,DF to value
    bdf  45        ; Short branch on DF=1
    shl            ; Shift left D
    dec ra         ; Decrement (RA)
    glo rb         ; Get low register RB
    shrc           ; Shift right with carry
    plo rb         ; Put low register RB
    lsdf           ; Long skip on DF=1
    seq            ; Set Q=1
    db $c8,$7a,$c4      ; Long skip
    glo ra         ; Get low register RA
    bnz  $44        ; Short branch on D!=0
    sep r5         ; Set P=R5 as program counter
;;
keys: 	;Gets 1 character from the serial
    glo r9         ; Get low register R9
    smi $71         ; Substract D,DF to value
    plo ra         ; Put low register RA
    ghi r9         ; Get high register R9
    smbi 00          ; Substract memory toh borrow, immediate
    phi ra         ; Put high register RA
    ldn ra         ; Load D with (RA)
    str r6         ; Store D to (R6)
    inc ra         ; Increment (RA)
    lda ra         ; Load D from (RA), increment RA
    phi rb         ; Put high register RB
    plo rb         ; Put low register RB
    ghi rb         ; Get high register RB
    dec rb         ; Decrement (RB)
    bz  $8a         ; Short branch on D=0
    bn4  $6b        ; Short branch on EF4=0
    ghi rb         ; Get high register RB
    dec rb         ; Decrement (RB)
    bz  $8a         ; Short branch on D=0
    b4  $71         ; Short branch on EF4=1
    ldn r6         ; Load D with (R6)
    shr            ; Shift right D
    str r2         ; Store D to (R2)
    smi 01         ; Substract D,DF to value
    bdf  $7a        ; Short branch on DF=1
    ldx            ; Pop stack. Place value in D register
    smi 11         ; Substract D,DF to value
    bdf  $79        ; Short branch on DF=1
    b4  $71         ; Short branch on EF4=1
    ldi $0a         ; Load D immediate
    plo rb         ; Put low register RB
    br  $9a         ; Short branch
;;
    stxd           ; Store via X and devrement
    sep r5         ; Set P=R5 as program counter
;;
    ldx            ; Pop stack. Place value in D register
    shrc           ; Shift right with carry
    str r2         ; Store D to (R2)
    ldn r6         ; Load D with (R6)
    phi rb         ; Put high register RB
    smi 01         ; Substract D,DF to value
    bdf  $91        ; Short branch on DF=1
    ghi rb         ; Get high register RB
    smi 23         ; Substract D,DF to value
    bdf  $90        ; Short branch on DF=1
    ldn ra         ; Load D with (RA)
    bnz  $a2        ; Short branch on D!=0
    ldn ra         ; Load D with (RA)
    b4  $a8         ; Short branch on EF4=1
    br  $aa         ; Short branch
    b4  $a7         ; Short branch on EF4=1
    seq            ; Set Q=1
    br  $aa         ; Short branch
    req            ; Reset Q=0
    smi 00         ; Substract D,DF to value
    dec rb         ; Decrement (RB)
    glo rb         ; Get low register RB
    bnz  $8c        ; Short branch on D!=0
;;
    bnf  $b5        ; Short branch on DF=0
    ldx            ; Pop stack. Place value in D register
    ani $7f         ; Logical AND D with value
    stxd           ; Store via X and devrement
    sep r5         ; Set P=R5 as program counter
    stxd           ; Store via X and devrement
    sep r5         ; Set P=R5 as program counter
qwri:
    inc r2         ; Increment (R2)
    ldx            ; Pop stack. Place value in D register
    bz  $bd         ; Short branch on D=0
    seq            ; Set Q=1
    sep r5         ; Set P=R5 as program counter
    req            ; Reset Q=0
    sep r5         ; Set P=R5 as program counter
dmawri:
    irx            ; Increment register X
    ldxa           ; Load via X and advance
    phi r0         ; Put high register R0
    ldx            ; Pop stack. Place value in D register
    plo r0         ; Put low register R0
    sep r5         ; Set P=R5 as program counter
dupnz:
    irx            ; Increment register X
    ldx            ; Pop stack. Place value in D register
    stxd           ; Store via X and devrement
    lsz            ; Long skip on D=0
    stxd           ; Store via X and devrement
    sep r5         ; Set P=R5 as program counter
    sep r5         ; Set P=R5 as program counter
append:
    irx            ; Increment register X
    ldxa           ; Load via X and advance
    phi ra         ; Put high register RA
    ldxa           ; Load via X and advance
    plo ra         ; Put low register RA
    ldx            ; Pop stack. Place value in D register
    lsnz           ; Long skip on D!=0
    stxd           ; Store via X and devrement
    sep r5         ; Set P=R5 as program counter
    plo rb         ; Put low register RB
    dec rb         ; Decrement (RB)
    irx            ; Increment register X
    ldx            ; Pop stack. Place value in D register
    phi rb         ; Put high register RB
    glo rb         ; Get low register RB
    stxd           ; Store via X and devrement
    ldn ra         ; Load D with (RA)
    adi 01         ; Add D,DF with value
    lsnf           ; Long skip on DF=0
    sep r5         ; Set P=R5 as program counter
    nop            ; No operation
    str ra         ; Store D to (RA)
    str r2         ; Store D to (R2)
    glo ra         ; Get low register RA
    add            ; Add D: D,DF= D+(R(X))
    plo ra         ; Put low register RA
    ghi ra         ; Get high register RA
    adci 00        ; Add with carry immediate
    phi ra         ; Put high register RA
    ghi rb         ; Get high register RB
    str ra         ; Store D to (RA)
    sep r5         ; Set P=R5 as program counter
dadd:
    irx            ; Increment register X
    ldxa           ; Load via X and advance
    phi ra         ; Put high register RA
    ldxa           ; Load via X and advance
    plo ra         ; Put low register RA
    ldxa           ; Load via X and advance
    phi rb         ; Put high register RB
    glo ra         ; Get low register RA
    add            ; Add D: D,DF= D+(R(X))
    stxd           ; Store via X and devrement
    ghi rb         ; Get high register RB
    str r2         ; Store D to (R2)
    ghi ra         ; Get high register RA
    adc            ; Add with carry
    stxd           ; Store via X and devrement
    sep r5         ; Set P=R5 as program counter
stwri:
    irx            ; Increment register X
    ldxa           ; Load via X and advance
    phi ra         ; Put high register RA
    ldxa           ; Load via X and advance
    plo ra         ; Put low register RA
    ldx            ; Pop stack. Place value in D register
    plo rb         ; Put low register RB
    ldxa           ; Load via X and advance
    str ra         ; Store D to (RA)
    inc ra         ; Increment (RA)
    glo rb         ; Get low register RB
    dec rb         ; Decrement (RB)
    bnz  05        ; Short branch on D!=0
    dec r2         ; Decrement (R2)
    sep r5         ; Set P=R5 as program counter
stlod:
    glo r7         ; Get low register R7
    str r2         ; Store D to (R2)
    ldn r7         ; Load D with (R7)
    add            ; Add D: D,DF= D+(R(X))
    plo r7         ; Put low register R7
    dec r2         ; Decrement (R2)
    ghi r7         ; Get high register R7
    stxd           ; Store via X and devrement
    adci 00        ; Add with carry immediate
    phi r7         ; Put high register R7
    inc r7         ; Increment (R7)
stat:
    irx            ; Increment register X
    ldxa           ; Load via X and advance
    phi ra         ; Put high register RA
    ldx            ; Pop stack. Place value in D register
    plo ra         ; Put low register RA
    ldn ra         ; Load D with (RA)
    plo rb         ; Put low register RB
    add            ; Add D: D,DF= D+(R(X))
    plo ra         ; Put low register RA
    ghi ra         ; Get high register RA
    adci 00        ; Add with carry immediate
    phi ra         ; Put high register RA
    ldn ra         ; Load D with (RA)
    stxd           ; Store via X and devrement
    dec ra         ; Decrement (RA)
    glo rb         ; Get low register RB
    dec rb         ; Decrement (RB)
    bnz  $27        ; Short branch on D!=0
    sep r5         ; Set P=R5 as program counter
stdr:
    irx            ; Increment register X
    ldx            ; Pop stack. Place value in D register
    irx            ; Increment register X
    smi 01         ; Substract D,DF to value
    bdf  $31        ; Short branch on DF=1
    dec r2         ; Decrement (R2)
    sep r5         ; Set P=R5 as program counter
dsub:
    irx            ; Increment register X
    ldxa           ; Load via X and advance
    phi ra         ; Put high register RA
    ldxa           ; Load via X and advance
    plo ra         ; Put low register RA
    ldxa           ; Load via X and advance
    phi rb         ; Put high register RB
    glo ra         ; Get low register RA
    sd             ; Substract D: D,DF=(R(X))-D
    stxd           ; Store via X and devrement
    ghi rb         ; Get high register RB
    str r2         ; Store D to (R2)
    ghi ra         ; Get high register RA
    sdb            ; Substract D with borrow
    stxd           ; Store via X and devrement
    sep r5         ; Set P=R5 as program counter
word:
    irx            ; Increment register X
    ldxa           ; Load via X and advance
    phi ra         ; Put high register RA
    phi rb         ; Put high register RB
    ldxa           ; Load via X and advance
    plo ra         ; Put low register RA
    plo rb         ; Put low register RB
    inc rb         ; Increment (RB)
    glo r7         ; Get low register R7
    str r6         ; Store D to (R6)
    ldi 00         ; Load D immediate
    plo r7         ; Put low register R7
;;
    ldn ra         ; Load D with (RA)
    bz  $68         ; Short branch on D=0
    smi 01         ; Substract D,DF to value
    str ra         ; Store D to (RA)
    lda rb         ; Load D from (RB), increment RB
    xor            ; Logical exclusive OR  D with (R(X))
    bz  $65         ; Short branch on D=0
    inc r7         ; Increment (R7)
    xor            ; Logical exclusive OR  D with (R(X))
    inc r6         ; Increment (R6)
    str r6         ; Store D to (R6)
    br  $55         ; Short branch
    glo r7         ; Get low register R7
    bz  $55         ; Short branch on D=0
;;
    ldn ra         ; Load D with (RA)
    bz  74         ; Short branch on D=0
    smi 01         ; Substract D,DF to value
    str r2         ; Store D to (R2)
    lda rb         ; Load D from (RB), increment RB
    inc ra         ; Increment (RA)
    str ra         ; Store D to (RA)
    ldx            ; Pop stack. Place value in D register
    bnz  $6b        ; Short branch on D!=0
;;
    glo r7         ; Get low register R7
    plo ra         ; Put low register RA
    bz  $7f         ; Short branch on D=0
    ldn r6         ; Load D with (R6)
    dec r6         ; Decrement (R6)
    stxd           ; Store via X and devrement
    dec ra         ; Decrement (RA)
    glo ra         ; Get low register RA
    bnz  $78        ; Short branch on D!=0
    glo r7         ; Get low register R7
    stxd           ; Store via X and devrement
    ldn r6         ; Load D with (R6)
    plo r7         ; Put low register R7
    sep r5         ; Set P=R5 as program counter
;;
find:	;Searches the vocabulary specified by 
    irx            ; Increment register X
    ldxa           ; Load via X and advance
    phi ra         ; Put high register RA
    ldx            ; Pop stack. Place value in D register
    plo ra         ; Put low register RA
    sex rb         ; Set P=RB as datapointer
;;
    ghi r2         ; Get high register R2
    phi rb         ; Put high register RB
    glo r2         ; Get low register R2
    plo rb         ; Put low register RB
    ldn ra         ; Load D with (RA)
    bnz  $a9        ; Short branch on D!=0
    inc ra         ; Increment (RA)
    lda ra         ; Load D from (RA), increment RA
    bnz  $9b        ; Short branch on D!=0
    ldn ra         ; Load D with (RA)
    bnz  $9b        ; Short branch on D!=0
    sex r2         ; Set P=R2 as datapointer
    stxd           ; Store via X and devrement
    sep r5         ; Set P=R5 as program counter
    ldn ra         ; Load D with (RA)
    plo rb         ; Put low register RB
    dec ra         ; Decrement (RA)
;;
    ldn ra         ; Load D with (RA)
    phi ra         ; Put high register RA
    glo rb         ; Get low register RB
    plo ra         ; Put low register RA
    br  89         ; Short branch
;;
    ldn r2         ; Load D with (R2)
    bz  $b9         ; Short branch on D=0
    smi 01         ; Substract D,DF to value
    str r2         ; Store D to (R2)
    lda ra         ; Load D from (RA), increment RA
    irx            ; Increment register X
    xor            ; Logical exclusive OR  D with (R(X))
    bz  $a4         ; Short branch on D=0
;;
    inc ra         ; Increment (RA)
    ldn r2         ; Load D with (R2)
    smi 01         ; Substract D,DF to value
    str r2         ; Store D to (R2)
    bdf  $af        ; Short branch on DF=1
    inc ra         ; Increment (RA)
    br  $8a         ; Short branch
;;
    sex r2         ; Set P=R2 as datapointer
    irx            ; Increment register X
    ldx            ; Pop stack. Place value in D register
    irx            ; Increment register X
    smi 01         ; Substract D,DF to value
    bdf  $bc        ; Short branch on DF=1
    dec r2         ; Decrement (R2)
    glo ra         ; Get low register RA
    stxd           ; Store via X and devrement
    ghi ra         ; Get high register RA
    stxd           ; Store via X and devrement
    ldi 01         ; Load D immediate
    stxd           ; Store via X and devrement
    sep r5         ; Set P=R5 as program counter
dover:
    ghi r2         ; Get high register R2
    phi ra         ; Put high register RA
    glo r2         ; Get low register R2
    plo ra         ; Put low register RA
    inc ra         ; Increment (RA)
    inc ra         ; Increment (RA)
    inc ra         ; Increment (RA)
    inc ra         ; Increment (RA)
    ldn ra         ; Load D with (RA)
    stxd           ; Store via X and devrement
    dec ra         ; Decrement (RA)
    lda ra         ; Load D from (RA), increment RA
    stxd           ; Store via X and devrement
    sep r5         ; Set P=R5 as program counter
lf:
    irx            ; Increment register X
    ldx            ; Pop stack. Place value in D register
    smi $0a         ; Substract D,DF to value
    lsnz           ; Long skip on D!=0
    stxd           ; Store via X and devrement
    sep r5         ; Set P=R5 as program counter
    dec r2         ; Decrement (R2)
    smi 03         ; Substract D,DF to value
    lsz            ; Long skip on D=0
    sep r5         ; Set P=R5 as program counter
    nop            ; No operation
    ldi $0a         ; Load D immediate
    stxd           ; Store via X and devrement
    sep r4         ; Set P=R4 as program counter
    dw $0571 
    dw $012c 
execute:
    glo r3         ; Get low register R3
    adi 04         ; Add D,DF with value
    plo ra         ; Put low register RA
    ghi r3         ; Get high register R3
    phi ra         ; Put high register RA
    inc ra         ; Increment (RA)
    sep ra         ; Set P=RA as program counter
    irx            ; Increment register X
    ldxa           ; Load via X and advance
    phi r3         ; Put high register R3
    ldx            ; Pop stack. Place value in D register
    plo r3         ; Put low register R3
    sep r3         ; Set P=R3 as program counter
mult:
    irx            ; Increment register X
    ldxa           ; Load via X and advance
    shr            ; Shift right D
    plo ra         ; Put low register RA
    ldi 00         ; Load D immediate
    phi ra         ; Put high register RA
    ldi 08         ; Load D immediate
    plo rb         ; Put low register RB
    ghi ra         ; Get high register RA
    bnf  $09        ; Short branch on DF=0
    add            ; Add D: D,DF= D+(R(X))
    shrc           ; Shift right with carry
    phi ra         ; Put high register RA
    glo ra         ; Get low register RA
    shrc           ; Shift right with carry
    plo ra         ; Put low register RA
    dec rb         ; Decrement (RB)
    glo rb         ; Get low register RB
    bnz  05        ; Short branch on D!=0
    glo ra         ; Get low register RA
    stxd           ; Store via X and devrement
    sep r5         ; Set P=R5 as program counter
multc:
    irx            ; Increment register X
    ldxa           ; Load via X and advance
    shr            ; Shift right D
    plo ra         ; Put low register RA
    ldxa           ; Load via X and advance
    plo rb         ; Put low register RB
    ldx            ; Pop stack. Place value in D register
    phi ra         ; Put high register RA
    glo rb         ; Get low register RB
    str r2         ; Store D to (R2)
    ldi 08         ; Load D immediate
    plo rb         ; Put low register RB
    ghi ra         ; Get high register RA
    bnf  $26        ; Short branch on DF=0
    add            ; Add D: D,DF= D+(R(X))
    shrc           ; Shift right with carry
    phi ra         ; Put high register RA
    glo ra         ; Get low register RA
    shrc           ; Shift right with carry
    plo ra         ; Put low register RA
    dec rb         ; Decrement (RB)
    glo rb         ; Get low register RB
    bnz  $22        ; Short branch on D!=0
    glo ra         ; Get low register RA
    stxd           ; Store via X and devrement
    ghi ra         ; Get high register RA
    stxd           ; Store via X and devrement
    sep r5         ; Set P=R5 as program counter
stdup:
    irx            ; Increment register X
    glo r2         ; Get low register R2
    add            ; Add D: D,DF= D+(R(X))
    plo ra         ; Put low register RA
    ghi r2         ; Get high register R2
    adci 00        ; Add with carry immediate
    phi ra         ; Put high register RA
    ldx            ; Pop stack. Place value in D register
    plo rb         ; Put low register RB
    dec r2         ; Decrement (R2)
    ldn ra         ; Load D with (RA)
    dec ra         ; Decrement (RA)
    stxd           ; Store via X and devrement
    glo rb         ; Get low register RB
    dec rb         ; Decrement (RB)
    bnz  $3f        ; Short branch on D!=0
    sep r5         ; Set P=R5 as program counter
digit:
    irx            ; Increment register X
    ldxa           ; Load via X and advance
    plo ra         ; Put low register RA
    ldx            ; Pop stack. Place value in D register
    smi $30         ; Substract D,DF to value
    bnf  $62        ; Short branch on DF=0
    smi $0a         ; Substract D,DF to value
    bnf  $57        ; Short branch on DF=0
    smi $07         ; Substract D,DF to value
    bnf  $62        ; Short branch on DF=0
    adi $0a         ; Add D,DF with value
    str r2         ; Store D to (R2)
    glo ra         ; Get low register RA
    sd             ; Substract D: D,DF=(R(X))-D
    bdf  $62        ; Short branch on DF=1
    dec r2         ; Decrement (R2)
    ldi 01         ; Load D immediate
    db $c8,$f8,00      ; Long skip
    stxd           ; Store via X and devrement
    sep r5         ; Set P=R5 as program counter
addc:
    ldi 00         ; Load D immediate
    plo ra         ; Put low register RA
    irx            ; Increment register X
    ldxa           ; Load via X and advance
    add            ; Add D: D,DF= D+(R(X))
    bnf  $6f        ; Short branch on DF=0
    inc ra         ; Increment (RA)
    irx            ; Increment register X
    add            ; Add D: D,DF= D+(R(X))
    stxd           ; Store via X and devrement
    glo ra         ; Get low register RA
    adci 00        ; Add with carry immediate
    stxd           ; Store via X and devrement
    sep r5         ; Set P=R5 as program counter
divide:
    irx            ; Increment register X
    ldxa           ; Load via X and advance
    phi rb         ; Put high register RB
    glo r2         ; Get low register R2
    plo ra         ; Put low register RA
    ghi r2         ; Get high register R2
    phi ra         ; Put high register RA
    inc ra         ; Increment (RA)
    ldi 08         ; Load D immediate
    plo rb         ; Put low register RB
    ghi rb         ; Get high register RB
    sd             ; Substract D: D,DF=(R(X))-D
    bnf  $9c        ; Short branch on DF=0
    ldi $ff         ; Load D immediate
    str ra         ; Store D to (RA)
    stxd           ; Store via X and devrement
    sep r5         ; Set P=R5 as program counter
    dec rb         ; Decrement (RB)
    ldx            ; Pop stack. Place value in D register
    shlc           ; Shift left with carry
    str r2         ; Store D to (R2)
    ghi rb         ; Get high register RB
    bnf  $98        ; Short branch on DF=0
    sd             ; Substract D: D,DF=(R(X))-D
    str r2         ; Store D to (R2)
    smi 00         ; Substract D,DF to value
    br  $9c         ; Short branch
    sd             ; Substract D: D,DF=(R(X))-D
    bnf  $9c        ; Short branch on DF=0
    str r2         ; Store D to (R2)
    ldn ra         ; Load D with (RA)
    shlc           ; Shift left with carry
    str ra         ; Store D to (RA)
    glo rb         ; Get low register RB
    bnz  $8b        ; Short branch on D!=0
    dec r2         ; Decrement (R2)
    sep r5         ; Set P=R5 as program counter
dat:
    irx            ; Increment register X
    ldxa           ; Load via X and advance
    phi ra         ; Put high register RA
    ldx            ; Pop stack. Place value in D register
    plo ra         ; Put low register RA
    inc ra         ; Increment (RA)
    ldn ra         ; Load D with (RA)
    stxd           ; Store via X and devrement
    dec ra         ; Decrement (RA)
    ldn ra         ; Load D with (RA)
    stxd           ; Store via X and devrement
    sep r5         ; Set P=R5 as program counter
dwri:
    irx            ; Increment register X
    ldxa           ; Load via X and advance
    phi ra         ; Put high register RA
    ldxa           ; Load via X and advance
    plo ra         ; Put low register RA
    ldxa           ; Load via X and advance
    str ra         ; Store D to (RA)
    inc ra         ; Increment (RA)
    ldx            ; Pop stack. Place value in D register
    str ra         ; Store D to (RA)
    sep r5         ; Set P=R5 as program counter
spat:
    ghi r2         ; Get high register R2
    phi ra         ; Put high register RA
    glo r2         ; Get low register R2
    stxd           ; Store via X and devrement
    ghi ra         ; Get high register RA
    stxd           ; Store via X and devrement
    sep r5         ; Set P=R5 as program counter
rspat:
    glo r6         ; Get low register R6
    stxd           ; Store via X and devrement
    ghi r6         ; Get high register R6
    stxd           ; Store via X and devrement
    sep r5         ; Set P=R5 as program counter
datamove:
    irx            ; Increment register X
    ldxa           ; Load via X and advance
    phi ra         ; Put high register RA
    ldx            ; Pop stack. Place value in D register
    plo ra         ; Put low register RA
    glo ra         ; Get low register RA
    bnz  d2        ; Short branch on D!=0
    ghi ra         ; Get high register RA
    bz  $d9         ; Short branch on D=0
    irx            ; Increment register X
    ldx            ; Pop stack. Place value in D register
    str r6         ; Store D to (R6)
    inc r6         ; Increment (R6)
    dec ra         ; Decrement (RA)
    br  $cc         ; Short branch
    sep r5         ; Set P=R5 as program counter
dless:
    irx            ; Increment register X
    ldxa           ; Load via X and advance
    phi ra         ; Put high register RA
    ldxa           ; Load via X and advance
    plo ra         ; Put low register RA
    ldxa           ; Load via X and advance
    phi rb         ; Put high register RB
    glo ra         ; Get low register RA
    sd             ; Substract D: D,DF=(R(X))-D
    ghi rb         ; Get high register RB
    str r2         ; Store D to (R2)
    ghi ra         ; Get high register RA
    sdb            ; Substract D with borrow
    ldi $ff         ; Load D immediate
    lsnf           ; Long skip on DF=0
    xri $ff         ; Logical XOR D with value
    stxd           ; Store via X and devrement
    sep r5         ; Set P=R5 as program counter
dswap:
    irx            ; Increment register X
    ldxa           ; Load via X and advance
    phi ra         ; Put high register RA
    ldxa           ; Load via X and advance
    plo ra         ; Put low register RA
    ldxa           ; Load via X and advance
    phi rb         ; Put high register RB
    ldx            ; Pop stack. Place value in D register
    plo rb         ; Put low register RB
    glo ra         ; Get low register RA
    stxd           ; Store via X and devrement
    ghi ra         ; Get high register RA
    stxd           ; Store via X and devrement
    glo rb         ; Get low register RB
    stxd           ; Store via X and devrement
    ghi rb         ; Get high register RB
    stxd           ; Store via X and devrement
    sep r5         ; Set P=R5 as program counter
rtnmove:
    irx            ; Increment register X
    ldxa           ; Load via X and advance
    phi ra         ; Put high register RA
    ldx            ; Pop stack. Place value in D register
    plo ra         ; Put low register RA
    glo ra         ; Get low register RA
    bnz  $0b        ; Short branch on D!=0
    ghi ra         ; Get high register RA
    bz  11         ; Short branch on D=0
    dec r6         ; Decrement (R6)
    ldn r6         ; Load D with (R6)
    stxd           ; Store via X and devrement
    dec ra         ; Decrement (RA)
    br  $05         ; Short branch
    sep r5         ; Set P=R5 as program counter
;;
    ;following definitions need conversion
    ;from 1802 instructions to DW addresses to words
    ; see assembly source for V1.0 for guidance
maxram:
    sep r8         ; Set P=R8 as program counter
    dw $0001
minram:
    sep r8         ; Set P=R8 as program counter
    dw $0003   
sp0:
    sep r8         ; Set P=R8 as program counter
    dw $0005
rsp0:
    sep r8         ; Set P=R8 as program counter
    idl            ; Idle or wait for interrupt or DMA request
    ldn r7         ; Load D with (R7)
first:
    sep r8         ; Set P=R8 as program counter
    idl            ; Idle or wait for interrupt or DMA request
    ldn r9         ; Load D with (R9)
next2:
    sep r8         ; Set P=R8 as program counter
    idl            ; Idle or wait for interrupt or DMA request
    ldn rb         ; Load D with (RB)
call2:
    sep r8         ; Set P=R8 as program counter
    idl            ; Idle or wait for interrupt or DMA request
    ldn rd         ; Load D with (RD)
intrupt1:
    sep r8         ; Set P=R8 as program counter
    idl            ; Idle or wait for interrupt or DMA request
    ldn rf         ; Load D with (RF)
vat:
    sep r8         ; Set P=R8 as program counter
    idl            ; Idle or wait for interrupt or DMA request
    inc r1         ; Increment (R1)
dma2:
    sep r8         ; Set P=R8 as program counter
    idl            ; Idle or wait for interrupt or DMA request
    inc r3         ; Increment (R3)
current:
    sep r8         ; Set P=R8 as program counter
    idl            ; Idle or wait for interrupt or DMA request
    inc r5         ; Increment (R5)
context:
    sep r8         ; Set P=R8 as program counter
    idl            ; Idle or wait for interrupt or DMA request
    inc r7         ; Increment (R7)
n:
    sep r8         ; Set P=R8 as program counter
    idl            ; Idle or wait for interrupt or DMA request
    inc r9         ; Increment (R9)
base:
    sep r8         ; Set P=R8 as program counter
    idl            ; Idle or wait for interrupt or DMA request
    inc ra         ; Increment (RA)
termnatr:
    sep r8         ; Set P=R8 as program counter
    idl            ; Idle or wait for interrupt or DMA request
    inc rb         ; Increment (RB)
delmiter:
    sep r8         ; Set P=R8 as program counter
    idl            ; Idle or wait for interrupt or DMA request
    inc rc         ; Increment (RC)
buffer: 
    sep r8         ; Set P=R8 as program counter
    idl            ; Idle or wait for interrupt or DMA request
    inp 5          ; Input to (R(X)) and D, N=101
caps:
    sep r8         ; Set P=R8 as program counter
    idl            ; Idle or wait for interrupt or DMA request
    inp 6          ; Input to (R(X)) and D, N=110
echo1:
    sep r8         ; Set P=R8 as program counter
    idl            ; Idle or wait for interrupt or DMA request
    inp 7          ; Input to (R(X)) and D, N=111
nocycles:
    sep r8         ; Set P=R8 as program counter
    idl            ; Idle or wait for interrupt or DMA request
    ret            ; Return from interrupt, set IE=1
baud:
    sep r8         ; Set P=R8 as program counter
    idl            ; Idle or wait for interrupt or DMA request
    dis            ; Disable. Return from interrupt, set IE=0
lastkeyn:
    sep r8         ; Set P=R8 as program counter
    idl            ; Idle or wait for interrupt or DMA request
    ldxa           ; Load via X and advance
stabort:
    sep r4         ; Set P=R4 as program counter
    ldn r5         ; Load D with (R5)
    lda r2         ; Load D from (R2), increment R2
    ldn r2         ; Load D with (R2)
    shl            ; Shift left D
    ldn r1         ; Load D with (R1)
    ldn re         ; Load D with (RE)
    ldn r1         ; Load D with (R1)
    dec rc         ; Decrement (RC)
basat:
    sep r4         ; Set P=R4 as program counter
    ldn r5         ; Load D with (R5)
    bnq  02        ; Short branch on Q=0
    inc re         ; Increment (RE)
    ldn r1         ; Load D with (R1)
    dec rc         ; Decrement (RC)
curntat:
    sep r4         ; Set P=R4 as program counter
    ldn r5         ; Load D with (R5)
    br  04         ; Short branch
    plo r4         ; Put low register R4
    ldn r1         ; Load D with (R1)
    dec rc         ; Decrement (RC)
input:
    sep r8         ; Set P=R8 as program counter
    idl            ; Idle or wait for interrupt or DMA request
    adc            ; Add with carry
output:
    sep r8         ; Set P=R8 as program counter
    idl            ; Idle or wait for interrupt or DMA request
    shrc           ; Shift right with carry
emit:
    sep r4         ; Set P=R4 as program counter
    ldn r5         ; Load D with (R5)
    inp 6          ; Input to (R(X)) and D, N=110
    ldn r4         ; Load D with (R4)
    plo r4         ; Put low register R4
    ldn r3         ; Load D with (R3)
    sex rd         ; Set P=RD as datapointer
    ldn r1         ; Load D with (R1)
    dec rc         ; Decrement (RC)
type:
    sep r4         ; Set P=R4 as program counter
    ldn r2         ; Load D with (R2)
    lsnq           ; Long skip on Q=0
    ldn r1         ; Load D with (R1)
    or             ; Logical OR  D with (R(X))
    ldn r5         ; Load D with (R5)
    glo r9         ; Get low register R9
    idl            ; Idle or wait for interrupt or DMA request
    ldn r1         ; Load D with (R1)
    ldn r1         ; Load D with (R1)
    phi r2         ; Put high register R2
    ldn r5         ; Load D with (R5)
    dis            ; Disable. Return from interrupt, set IE=0
    ldn r1         ; Load D with (R1)
    lbz $012c       ; Long branch on D=0
cr:
    sep r4         ; Set P=R4 as program counter
    ldn r3         ; Load D with (R3)
    ldn re         ; Load D with (RE)
    ldn r2         ; Load D with (R2)
    ldn ra         ; Load D with (RA)
    ldn rd         ; Load D with (RD)
    ldn r5         ; Load D with (R5)
    req            ; Reset Q=0
    ldn r1         ; Load D with (R1)
    dec rc         ; Decrement (RC)
memful:
    sep r4         ; Set P=R4 as program counter
    ldn r4         ; Load D with (R4)
    phi rb         ; Put high register RB
    ldn r4         ; Load D with (R4)
    lbz $0020       ; Long branch on D=0
    idl            ; Idle or wait for interrupt or DMA request
    idl            ; Idle or wait for interrupt or DMA request
    ldn r2         ; Load D with (R2)
    sex re         ; Set P=RE as datapointer
    ldn r4         ; Load D with (R4)
    sep ra         ; Set P=RA as program counter
    ldn r1         ; Load D with (R1)
    bdf  01        ; Short branch on DF=1
    or             ; Logical OR  D with (R(X))
    ldn r5         ; Load D with (R5)
    phi rc         ; Put high register RC
    ldn r3         ; Load D with (R3)
    ldn re         ; Load D with (RE)
;;
    db $0d,' MEMORY FULL',$13
;;
    dw  type
    dw  cr
    dw  return

check:
    sep r4         ; Set P=R4 as program counter
    ldn r5         ; Load D with (R5)
    inc r8         ; Increment (R8)
    ldn r4         ; Load D with (R4)
    plo r4         ; Put low register R4
    ldn r4         ; Load D with (R4)
    phi rb         ; Put high register RB
    idl            ; Idle or wait for interrupt or DMA request
    ldn r8         ; Load D with (R8)
    idl            ; Idle or wait for interrupt or DMA request
    idl            ; Idle or wait for interrupt or DMA request
    ldn r2         ; Load D with (R2)
    sex re         ; Set P=RE as datapointer
    ldn r4         ; Load D with (R4)
    sep ra         ; Set P=RA as program counter
    ldn r1         ; Load D with (R1)
    or             ; Logical OR  D with (R(X))
    ldn r5         ; Load D with (R5)
    sex r3         ; Set P=R3 as datapointer
    ldn r3         ; Load D with (R3)
    ldn re         ; Load D with (RE)
;;
    ;following is ASCII
    db $0d,' STACK EMPTY',$13
    dw stabort
    dw  rspat
    dw rsp0
    dw dat
    dw dless
    dw br0
    dw check2 
    dw stlod
    ;following is ASCII
    db $14,' RETURN STACK EMPTY',$13
    dw stabort
check2:
    dw memful
    dw br0
    dw check3
    dw abort
check3:
    dw return

getakey:
    sep r4         ; Set P=R4 as program counter
    ldn r1         ; Load D with (R1)
    ghi rc         ; Get high register RC
    ldn r5         ; Load D with (R5)
    inp 3          ; Input to (R(X)) and D, N=011
    ldn r4         ; Load D with (R4)
    plo r4         ; Put low register R4
    ldn r3         ; Load D with (R3)
    sex rd         ; Set P=RD as datapointer
    ldn r3         ; Load D with (R3)
    sep r8         ; Set P=R8 as program counter
    ldn r2         ; Load D with (R2)
    lsnq           ; Long skip on Q=0
    ldn r1         ; Load D with (R1)
    plo r3         ; Put low register R3
    ldn r1         ; Load D with (R1)
    dec rc         ; Decrement (RC)
expect:
    sep r4         ; Set P=R4 as program counter
    idl            ; Idle or wait for interrupt or DMA request
    inc r1         ; Increment (R1)
    idl            ; Idle or wait for interrupt or DMA request
    ldn r1         ; Load D with (R1)
    ldn r5         ; Load D with (R5)
    req            ; Reset Q=0
    idl            ; Idle or wait for interrupt or DMA request
    idl            ; Idle or wait for interrupt or DMA request
    ldn r5         ; Load D with (R5)
    lda r2         ; Load D from (R2), increment R2
    ldn r2         ; Load D with (R2)
    dec r6         ; Decrement (R6)
    ldn r1         ; Load D with (R1)
    bdf  01        ; Short branch on DF=1
    or             ; Logical OR  D with (R(X))
    ldn r6         ; Load D with (R6)
    phi r6         ; Put high register R6
    ldn r1         ; Load D with (R1)
    ghi rc         ; Get high register RC
    ldn r6         ; Load D with (R6)
    inc r2         ; Increment (R2)
    ldn r1         ; Load D with (R1)
    bdf  08        ; Short branch on DF=1
    ghi re         ; Get high register RE
    ldn r2         ; Load D with (R2)
    inc re         ; Increment (RE)
    ldn r1         ; Load D with (R1)
    glo r0         ; Get low register R0
    ldn r1         ; Load D with (R1)
    or             ; Logical OR  D with (R(X))
    ldn r6         ; Load D with (R6)
    str rc         ; Store D to (RC)
    ldn r5         ; Load D with (R5)
    lda r2         ; Load D from (R2), increment R2
    ldn r2         ; Load D with (R2)
    inc re         ; Increment (RE)
    ldn r2         ; Load D with (R2)
    lsnq           ; Long skip on Q=0
    ldn r1         ; Load D with (R1)
    or             ; Logical OR  D with (R(X))
    ldn r6         ; Load D with (R6)
    str r8         ; Store D to (R8)
    idl            ; Idle or wait for interrupt or DMA request
    ldn r1         ; Load D with (R1)
    ldn r1         ; Load D with (R1)
    out 3          ; Output (R(X)); Increment R(X), N=011
    ldn r5         ; Load D with (R5)
    lda r2         ; Load D from (R2), increment R2
    ldn r2         ; Load D with (R2)
    dec r6         ; Decrement (R6)
    ldn r1         ; Load D with (R1)
    ldi 06         ; Load D immediate
    plo r4         ; Put low register R4
    ldn r1         ; Load D with (R1)
    bdf  08        ; Short branch on DF=1
    ghi rb         ; Get high register RB
    ldn r2         ; Load D with (R2)
    inc re         ; Increment (RE)
    ldn r1         ; Load D with (R1)
    glo r0         ; Get low register R0
    ldn r1         ; Load D with (R1)
    or             ; Logical OR  D with (R(X))
    ldn r6         ; Load D with (R6)
    glo r2         ; Get low register R2
    ldn r3         ; Load D with (R3)
    ldn re         ; Load D with (RE)
;;
    ;following is ASCII
    ldn r9         ; Load D with (R9)
    dec r0         ; Decrement (R0)
    bn1  $2d        ; Short branch on EF1=0
    lda r3         ; Load D from (R3), increment R3
    lda r1         ; Load D from (R1), increment R1
    lda re         ; Load D from (RE), increment RE
    lda r3         ; Load D from (R3), increment R3
    lda r5         ; Load D from (R5), increment R5
    lda rc         ; Load D from (RC), increment RC
;;
    ldn r5         ; Load D with (R5)
    req            ; Reset Q=0
    ldn r5         ; Load D with (R5)
    glo rb         ; Get low register RB
    idl            ; Idle or wait for interrupt or DMA request
    idl            ; Idle or wait for interrupt or DMA request
    ldn r5         ; Load D with (R5)
    lda r2         ; Load D from (R2), increment R2
    ldn r2         ; Load D with (R2)
    dec r6         ; Decrement (R6)
    ldn r1         ; Load D with (R1)
    ldi 06         ; Load D immediate
    plo r4         ; Put low register R4
    ldn r1         ; Load D with (R1)
    bdf  05        ; Short branch on DF=1
    bn1  02        ; Short branch on EF1=0
    inc re         ; Increment (RE)
    ldn r1         ; Load D with (R1)
    glo r0         ; Get low register R0
    ldn r1         ; Load D with (R1)
    or             ; Logical OR  D with (R(X))
    ldn r6         ; Load D with (R6)
    ghi re         ; Get high register RE
    idl            ; Idle or wait for interrupt or DMA request
    inc r3         ; Increment (R3)
    idl            ; Idle or wait for interrupt or DMA request
    ldn r1         ; Load D with (R1)
    ldn r5         ; Load D with (R5)
    req            ; Reset Q=0
    ldn r1         ; Load D with (R1)
    bnf  00        ; Short branch on DF=0
    idl            ; Idle or wait for interrupt or DMA request
    ldn r1         ; Load D with (R1)
    lda r6         ; Load D from (R6), increment R6
    ldn r1         ; Load D with (R1)
    ldi 06         ; Load D immediate
    plo r4         ; Put low register R4
    idl            ; Idle or wait for interrupt or DMA request
    ldn r1         ; Load D with (R1)
    ldn r5         ; Load D with (R5)
    lda r2         ; Load D from (R2), increment R2
    ldn r2         ; Load D with (R2)
    lsie           ; Long skip on IE=1
    ldn r1         ; Load D with (R1)
    bnf  01        ; Short branch on DF=0
    bdf  05        ; Short branch on DF=1
    lda r2         ; Load D from (R2), increment R2
    ldn r2         ; Load D with (R2)
    inc re         ; Increment (RE)
    ldn r1         ; Load D with (R1)
    glo ra         ; Get low register RA
    ldn r1         ; Load D with (R1)
    smb            ; Substract memory with borrow
    ldn r1         ; Load D with (R1)
    plo r3         ; Put low register R3
    ldn r1         ; Load D with (R1)
    ldi 06         ; Load D immediate
    phi ra         ; Put high register RA
    ldn r1         ; Load D with (R1)
    bnf  00        ; Short branch on DF=0
    ldn r1         ; Load D with (R1)
    ldn r1         ; Load D with (R1)
    dec rc         ; Decrement (RC)
dnumber:
    sep r4         ; Set P=R4 as program counter
    ldn r4         ; Load D with (R4)
    b1  01         ; Short branch on EF1=1
    bdf  01        ; Short branch on DF=1
    or             ; Logical OR  D with (R(X))
    ldn r7         ; Load D with (R7)
    dec r3         ; Decrement (R3)
    idl            ; Idle or wait for interrupt or DMA request
    idl            ; Idle or wait for interrupt or DMA request
    idl            ; Idle or wait for interrupt or DMA request
    idl            ; Idle or wait for interrupt or DMA request
    ldn r5         ; Load D with (R5)
    b3  04         ; Short branch on EF3=1
    phi r0         ; Put high register R0
    ldn r1         ; Load D with (R1)
    bdf  00        ; Short branch on DF=1
    ldn r1         ; Load D with (R1)
    ldn r1         ; Load D with (R1)
    phi r2         ; Put high register R2
    idl            ; Idle or wait for interrupt or DMA request
    ldn r1         ; Load D with (R1)
    ldn r1         ; Load D with (R1)
    out 3          ; Output (R(X)); Increment R(X), N=011
    ldn r1         ; Load D with (R1)
    lda r6         ; Load D from (R6), increment R6
    ldn r5         ; Load D with (R5)
    str rd         ; Store D to (RD)
    ldn r4         ; Load D with (R4)
    lda r7         ; Load D from (R7), increment R7
    ldn r1         ; Load D with (R1)
    or             ; Logical OR  D with (R(X))
    ldn r7         ; Load D with (R7)
    inc rb         ; Increment (RB)
    ldn r5         ; Load D with (R5)
    b3  04         ; Short branch on EF3=1
    plo r4         ; Put low register R4
    ldn r1         ; Load D with (R1)
    bnf  05        ; Short branch on DF=0
    str rd         ; Store D to (RD)
    ldn r4         ; Load D with (R4)
    inc r5         ; Increment (R5)
    ldn r5         ; Load D with (R5)
    b3  02         ; Short branch on EF3=1
    inc re         ; Increment (RE)
    ldn r5         ; Load D with (R5)
    str rd         ; Store D to (RD)
    ldn r4         ; Load D with (R4)
    inc r5         ; Increment (R5)
    ldn r1         ; Load D with (R1)
    or             ; Logical OR  D with (R(X))
    ldn r7         ; Load D with (R7)
    ldn r3         ; Load D with (R3)
    ldn r1         ; Load D with (R1)
    db $38, $03        ; Skip next byte
    dec rf         ; Decrement (RF)
    idl            ; Idle or wait for interrupt or DMA request
    idl            ; Idle or wait for interrupt or DMA request
    ldn r1         ; Load D with (R1)
    sex r7         ; Set P=R7 as datapointer
    ldn r1         ; Load D with (R1)
    ldi 07         ; Load D immediate
    inc r7         ; Increment (R7)
    ldn r5         ; Load D with (R5)
    b3  04         ; Short branch on EF3=1
    phi r0         ; Put high register R0
    ldn r2         ; Load D with (R2)
    lsnq           ; Long skip on Q=0
    ldn r1         ; Load D with (R1)
    smb            ; Substract memory with borrow
    ldn r1         ; Load D with (R1)
    or             ; Logical OR  D with (R(X))
    ldn r7         ; Load D with (R7)
    inc r7         ; Increment (R7)
    ldn r3         ; Load D with (R3)
    dec rf         ; Decrement (RF)
    ldn r5         ; Load D with (R5)
    b3  04         ; Short branch on EF3=1
    plo r4         ; Put low register R4
    idl            ; Idle or wait for interrupt or DMA request
    ldn r1         ; Load D with (R1)
    ldn r1         ; Load D with (R1)
    ldi 07         ; Load D immediate
    dec r1         ; Decrement (R1)
    ldn r3         ; Load D with (R3)
    dec rf         ; Decrement (RF)
    idl            ; Idle or wait for interrupt or DMA request
    idl            ; Idle or wait for interrupt or DMA request
    ldn r1         ; Load D with (R1)
    sex r7         ; Set P=R7 as datapointer
    ldn r1         ; Load D with (R1)
    lbz $012c       ; Long branch on D=0
number:
    sep r4         ; Set P=R4 as program counter
    ldn r6         ; Load D with (R6)
    phi rc         ; Put high register RC
    ldn r1         ; Load D with (R1)
    or             ; Logical OR  D with (R(X))
    ldn r7         ; Load D with (R7)
    lda r0         ; Load D from (R0), increment R0
    ldn r2         ; Load D with (R2)
    lsnq           ; Long skip on Q=0
    ldn r1         ; Load D with (R1)
    or             ; Logical OR  D with (R(X))
    ldn r7         ; Load D with (R7)
    bnz  07        ; Short branch on D!=0
    lda rb         ; Load D from (RB), increment RB
    idl            ; Idle or wait for interrupt or DMA request
    idl            ; Idle or wait for interrupt or DMA request
    ldn r1         ; Load D with (R1)
    ldi 07         ; Load D immediate
    bn1  00        ; Short branch on EF1=0
    ldn r1         ; Load D with (R1)
    ldn r1         ; Load D with (R1)
    ldi 07         ; Load D immediate
    lda r2         ; Load D from (R2), increment R2
    idl            ; Idle or wait for interrupt or DMA request
    idl            ; Idle or wait for interrupt or DMA request
    ldn r1         ; Load D with (R1)
    dec rc         ; Decrement (RC)
ddup:
    sep r4         ; Set P=R4 as program counter
    ldn r1         ; Load D with (R1)
    bn2  01        ; Short branch on EF2=0
    bn2  01        ; Short branch on EF2=0
    dec rc         ; Decrement (RC)
tonumber:
    sep r4         ; Set P=R4 as program counter
    ldn r5         ; Load D with (R5)
    str rd         ; Store D to (RD)
    idl            ; Idle or wait for interrupt or DMA request
    ldn r2         ; Load D with (R2)
    ldn r1         ; Load D with (R1)
    ghi r3         ; Get high register R3
    ldn r1         ; Load D with (R1)
    or             ; Logical OR  D with (R(X))
    ldn r7         ; Load D with (R7)
    str re         ; Store D to (RE)
    ldn r1         ; Load D with (R1)
    db $38, $00        ; Skip next byte
    idl            ; Idle or wait for interrupt or DMA request
    ldn r1         ; Load D with (R1)
    ldi 07         ; Load D immediate
    ghi ra         ; Get high register RA
    idl            ; Idle or wait for interrupt or DMA request
    inc r0         ; Increment (R0)
    idl            ; Idle or wait for interrupt or DMA request
    ldn r1         ; Load D with (R1)
    ldn r1         ; Load D with (R1)
    phi r2         ; Put high register R2
    idl            ; Idle or wait for interrupt or DMA request
    idl            ; Idle or wait for interrupt or DMA request
    ldn r5         ; Load D with (R5)
    str rd         ; Store D to (RD)
    ldn r4         ; Load D with (R4)
    smb            ; Substract memory with borrow
    ldn r1         ; Load D with (R1)
    str r0         ; Store D to (R0)
    ldn r1         ; Load D with (R1)
    lda r6         ; Load D from (R6), increment R6
    ldn r5         ; Load D with (R5)
    str rd         ; Store D to (RD)
    ldn r4         ; Load D with (R4)
    smb            ; Substract memory with borrow
    ldn r1         ; Load D with (R1)
    bdf  00        ; Short branch on DF=1
    ldn r9         ; Load D with (R9)
    ldn r1         ; Load D with (R1)
    glo ra         ; Get low register RA
    ldn r1         ; Load D with (R1)
    or             ; Logical OR  D with (R(X))
    ldn r7         ; Load D with (R7)
    glo r0         ; Get low register R0
    idl            ; Idle or wait for interrupt or DMA request
    ldn r7         ; Load D with (R7)
    ldn r1         ; Load D with (R1)
    str re         ; Store D to (RE)
    idl            ; Idle or wait for interrupt or DMA request
    br  01         ; Short branch
    str re         ; Store D to (RE)
    ldn r1         ; Load D with (R1)
    lda r6         ; Load D from (R6), increment R6
    ldn r1         ; Load D with (R1)
    str r0         ; Store D to (R0)
    ldn r7         ; Load D with (R7)
    lda r4         ; Load D from (R4), increment R4
    ldn r1         ; Load D with (R1)
    inp 5          ; Input to (R(X)) and D, N=101
    ldn r1         ; Load D with (R1)
    smb            ; Substract memory with borrow
    ldn r1         ; Load D with (R1)
    or             ; Logical OR  D with (R(X))
    ldn r7         ; Load D with (R7)
    ghi r8         ; Get high register R8
    ldn r1         ; Load D with (R1)
    db $38, $01        ; Skip next byte
    sex r3         ; Set P=R3 as datapointer
    ldn r1         ; Load D with (R1)
    sex r7         ; Set P=R7 as datapointer
    ldn r1         ; Load D with (R1)
    lbz $012c       ; Long branch on D=0
getword:
    sep r4         ; Set P=R4 as program counter
    ldn r1         ; Load D with (R1)
    ghi rc         ; Get high register RC
    ldn r5         ; Load D with (R5)
    bn4  02        ; Short branch on EF4=0
    inc re         ; Increment (RE)
    ldn r5         ; Load D with (R5)
    lda r2         ; Load D from (R2), increment R2
    ldn r3         ; Load D with (R3)
    lda r8         ; Load D from (R8), increment R8
    ldn r1         ; Load D with (R1)
    bdf  02        ; Short branch on DF=1
    lsnq           ; Long skip on Q=0
    ldn r1         ; Load D with (R1)
    smb            ; Substract memory with borrow
    ldn r1         ; Load D with (R1)
    or             ; Logical OR  D with (R(X))
    ldn r7         ; Load D with (R7)
    sep r7         ; Set P=R7 as program counter
    ldn r1         ; Load D with (R1)
    ghi rc         ; Get high register RC
    idl            ; Idle or wait for interrupt or DMA request
    str r0         ; Store D to (R0)
    ldn r6         ; Load D with (R6)
    dec r3         ; Decrement (R3)
    ldn r1         ; Load D with (R1)
    bdf  01        ; Short branch on DF=1
    or             ; Logical OR  D with (R(X))
    ldn r7         ; Load D with (R7)
    sep r3         ; Set P=R3 as program counter
    ldn r3         ; Load D with (R3)
    ldn re         ; Load D with (RE)
    ldn rf         ; Load D with (RF)
;;
    ;following is ASCII
    dec r0         ; Decrement (R0)
    lda rc         ; Load D from (RC), increment RC
    lda r9         ; Load D from (R9), increment R9
    lda re         ; Load D from (RE), increment RE
    lda r5         ; Load D from (R5), increment R5
    dec r0         ; Decrement (R0)
    str r4         ; Store D to (R4)
    lda rf         ; Load D from (RF), increment RF
    lda rf         ; Load D from (RF), increment RF
    dec r0         ; Decrement (R0)
    lda rc         ; Load D from (RC), increment RC
    lda rf         ; Load D from (RF), increment RF
    lda re         ; Load D from (RE), increment RE
    lda r7         ; Load D from (R7), increment R7
    inc r3         ; Increment (R3)
;;
    ldn r5         ; Load D with (R5)
    req            ; Reset Q=0
    ldn r5         ; Load D with (R5)
    glo rb         ; Get low register RB
    ldn r1         ; Load D with (R1)
    smb            ; Substract memory with borrow
    ldn r1         ; Load D with (R1)
    plo r3         ; Put low register R3
    ldn r1         ; Load D with (R1)
    plo r3         ; Put low register R3
    ldn r1         ; Load D with (R1)
    dec rc         ; Decrement (RC)
wordq:
    sep r4         ; Set P=R4 as program counter
    ldn r5         ; Load D with (R5)
    req            ; Reset Q=0
    ldn r3         ; Load D with (R3)
    ldn re         ; Load D with (RE)
    ldn r3         ; Load D with (R3)
    dec r0         ; Decrement (R0)
    bn4  $13        ; Short branch on EF4=0
    ldn r5         ; Load D with (R5)
    req            ; Reset Q=0
    ldn r5         ; Load D with (R5)
    glo rb         ; Get low register RB
    idl            ; Idle or wait for interrupt or DMA request
    idl            ; Idle or wait for interrupt or DMA request
    ldn r5         ; Load D with (R5)
    lda r2         ; Load D from (R2), increment R2
    ldn r2         ; Load D with (R2)
    dec r6         ; Decrement (R6)
    ldn r1         ; Load D with (R1)
    dec rc         ; Decrement (RC)
numberq:
    sep r4         ; Set P=R4 as program counter
    ldn r7         ; Load D with (R7)
    dec r5         ; Decrement (R5)
    ldn r1         ; Load D with (R1)
    or             ; Logical OR  D with (R(X))
    ldn r7         ; Load D with (R7)
    sdi 00         ; Substract D,DF from value
    ldn r1         ; Load D with (R1)
    ldn r1         ; Load D with (R1)
    ldi 08         ; Load D immediate
    ldn r1         ; Load D with (R1)
    ldn r7         ; Load D with (R7)
    sep rb         ; Set P=RB as program counter
    idl            ; Idle or wait for interrupt or DMA request
    idl            ; Idle or wait for interrupt or DMA request
    ldn r1         ; Load D with (R1)
    dec rc         ; Decrement (RC)
tick:
    sep r4         ; Set P=R4 as program counter
    ldn r7         ; Load D with (R7)
    ghi rc         ; Get high register RC
    ldn r5         ; Load D with (R5)
    out 4          ; Output (R(X)); Increment R(X), N=100
    ldn r4         ; Load D with (R4)
    plo r4         ; Put low register R4
    ldn r3         ; Load D with (R3)
    glo r4         ; Get low register R4
    ldn r2         ; Load D with (R2)
    lsnq           ; Long skip on Q=0
    ldn r1         ; Load D with (R1)
    smb            ; Substract memory with borrow
    ldn r1         ; Load D with (R1)
    or             ; Logical OR  D with (R(X))
    ldn r8         ; Load D with (R8)
    inc rc         ; Increment (RC)
    ldn r5         ; Load D with (R5)
    bdf  04        ; Short branch on DF=1
    plo r4         ; Put low register R4
    ldn r4         ; Load D with (R4)
    plo r4         ; Put low register R4
    ldn r3         ; Load D with (R3)
    glo r4         ; Get low register R4
    ldn r1         ; Load D with (R1)
    or             ; Logical OR  D with (R(X))
    ldn r8         ; Load D with (R8)
    dec r8         ; Decrement (R8)
    ldn r4         ; Load D with (R4)
    plo r4         ; Put low register R4
    idl            ; Idle or wait for interrupt or DMA request
    ldn r1         ; Load D with (R1)
    ldn r1         ; Load D with (R1)
    ldi 08         ; Load D immediate
    dec ra         ; Decrement (RA)
    idl            ; Idle or wait for interrupt or DMA request
    idl            ; Idle or wait for interrupt or DMA request
    ldn r1         ; Load D with (R1)
    dec rc         ; Decrement (RC)
intrpret:
    sep r4         ; Set P=R4 as program counter
    idl            ; Idle or wait for interrupt or DMA request
    idl            ; Idle or wait for interrupt or DMA request
    ldn r1         ; Load D with (R1)
    bdf  07        ; Short branch on DF=1
    lda r4         ; Load D from (R4), increment R4
    ldn r7         ; Load D with (R7)
    lda r4         ; Load D from (R4), increment R4
    ldn r1         ; Load D with (R1)
    ghi rc         ; Get high register RC
    ldn r5         ; Load D with (R5)
    lda r2         ; Load D from (R2), increment R2
    ldn r3         ; Load D with (R3)
    inc ra         ; Increment (RA)
    ldn r5         ; Load D with (R5)
    req            ; Reset Q=0
    ldn r5         ; Load D with (R5)
    glo rb         ; Get low register RB
    idl            ; Idle or wait for interrupt or DMA request
    idl            ; Idle or wait for interrupt or DMA request
    ldn r5         ; Load D with (R5)
    lda r2         ; Load D from (R2), increment R2
    ldn r2         ; Load D with (R2)
    dec r6         ; Decrement (R6)
    ldn r1         ; Load D with (R1)
    ghi rc         ; Get high register RC
    ldn r8         ; Load D with (R8)
    ldn r3         ; Load D with (R3)
    ldn r1         ; Load D with (R1)
    or             ; Logical OR  D with (R(X))
    ldn r8         ; Load D with (R8)
    str r3         ; Store D to (R3)
    ldn r3         ; Load D with (R3)
    sex rd         ; Set P=RD as datapointer
    ldn r1         ; Load D with (R1)
    ldi 08         ; Load D immediate
    str rd         ; Store D to (RD)
    ldn r7         ; Load D with (R7)
    ldx            ; Pop stack. Place value in D register
    ldn r1         ; Load D with (R1)
    smb            ; Substract memory with borrow
    ldn r1         ; Load D with (R1)
    or             ; Logical OR  D with (R(X))
    ldn r8         ; Load D with (R8)
    str rd         ; Store D to (RD)
    ldn r1         ; Load D with (R1)
    ldn re         ; Load D with (RE)
    ldn r5         ; Load D with (R5)
    phi re         ; Put high register RE
    ldn r5         ; Load D with (R5)
    lda r2         ; Load D from (R2), increment R2
    ldn r2         ; Load D with (R2)
    inc re         ; Increment (RE)
    ldn r1         ; Load D with (R1)
    smb            ; Substract memory with borrow
    ldn r1         ; Load D with (R1)
    plo r3         ; Put low register R3
    ldn r3         ; Load D with (R3)
    ldn re         ; Load D with (RE)
    ldn r3         ; Load D with (R3)
    dec r0         ; Decrement (R0)
    lda rf         ; Load D from (RF), increment RF
    lda rb         ; Load D from (RB), increment RB
    ldn r5         ; Load D with (R5)
    lda r2         ; Load D from (R2), increment R2
    ldn r2         ; Load D with (R2)
    shl            ; Shift left D
    idl            ; Idle or wait for interrupt or DMA request
    idl            ; Idle or wait for interrupt or DMA request
    ldn r1         ; Load D with (R1)
    plo r3         ; Put low register R3
    ldn r1         ; Load D with (R1)
    dec rc         ; Decrement (RC)
ddot:
    sep r4         ; Set P=R4 as program counter
    ldn r7         ; Load D with (R7)
    lda rb         ; Load D from (RB), increment RB
    ldn r5         ; Load D with (R5)
    req            ; Reset Q=0
    idl            ; Idle or wait for interrupt or DMA request
    dec r0         ; Decrement (R0)
    ldn r5         ; Load D with (R5)
    dis            ; Disable. Return from interrupt, set IE=0
    ldn r1         ; Load D with (R1)
    dec rc         ; Decrement (RC)
dot:
    sep r4         ; Set P=R4 as program counter
    idl            ; Idle or wait for interrupt or DMA request
    idl            ; Idle or wait for interrupt or DMA request
    ldn r8         ; Load D with (R8)
    smb            ; Substract memory with borrow
    ldn r1         ; Load D with (R1)
    dec rc         ; Decrement (RC)
decimal:
    sep r4         ; Set P=R4 as program counter
    idl            ; Idle or wait for interrupt or DMA request
    ldn ra         ; Load D with (RA)
    ldn r5         ; Load D with (R5)
    bnq  02        ; Short branch on Q=0
    dec r6         ; Decrement (R6)
    ldn r1         ; Load D with (R1)
    dec rc         ; Decrement (RC)
hex:
    sep r4         ; Set P=R4 as program counter
    idl            ; Idle or wait for interrupt or DMA request
    inc r0         ; Increment (R0)
    ldn r5         ; Load D with (R5)
    bnq  02        ; Short branch on Q=0
    dec r6         ; Decrement (R6)
    ldn r1         ; Load D with (R1)
    dec rc         ; Decrement (RC)
cancel:
    sep r8         ; Set P=R8 as program counter
    idl            ; Idle or wait for interrupt or DMA request
    smb            ; Substract memory with borrow
backspce:
    sep r8         ; Set P=R8 as program counter
    idl            ; Idle or wait for interrupt or DMA request
    sav            ; Save
openparen:
    sep r4         ; Set P=R4 as program counter
    ldn r1         ; Load D with (R1)
    ghi rc         ; Get high register RC
    ldn r7         ; Load D with (R7)
    ghi rc         ; Get high register RC
    ldn r7         ; Load D with (R7)
    lda r4         ; Load D from (R4), increment R4
    idl            ; Idle or wait for interrupt or DMA request
    dec r9         ; Decrement (R9)
    idl            ; Idle or wait for interrupt or DMA request
    ldn r1         ; Load D with (R1)
    ldn r3         ; Load D with (R3)
    db $38, $01        ; Skip next byte
    inp 5          ; Input to (R(X)) and D, N=101
    ldn r1         ; Load D with (R1)
    smb            ; Substract memory with borrow
    ldn r1         ; Load D with (R1)
    or             ; Logical OR  D with (R(X))
    ldn r8         ; Load D with (R8)
    phi re         ; Put high register RE
    ldn r3         ; Load D with (R3)
    dec rf         ; Decrement (RF)
    idl            ; Idle or wait for interrupt or DMA request
    ldn r1         ; Load D with (R1)
    ldn r1         ; Load D with (R1)
    ldi $08         ; Load D immediate
    lbz $032f       ; Long branch on D=0
    idl            ; Idle or wait for interrupt or DMA request
    idl            ; Idle or wait for interrupt or DMA request
    ldn r1         ; Load D with (R1)
    plo r3         ; Put low register R3
    ldn r1         ; Load D with (R1)
    dec rc         ; Decrement (RC)
quote:         ;hrj double quote
    sep r4         ; Set P=R4 as program counter
    idl            ; Idle or wait for interrupt or DMA request
    dec r2         ; Decrement (R2)
    ldn r5         ; Load D with (R5)
    lda r2         ; Load D from (R2), increment R2
    ldn r3         ; Load D with (R3)
    lda r8         ; Load D from (R8), increment R8
    ldn r1         ; Load D with (R1)
    dec rc         ; Decrement (RC)
size:
    sep r8         ; Set P=R8 as program counter
    idl            ; Idle or wait for interrupt or DMA request
    req            ; Reset Q=0
user:           ;hrj could be error?
    sep r8         ; Set P=R8 as program counter
    idl            ; Idle or wait for interrupt or DMA request
    db 7ch
eighth:         ;hrj could be error?
    sep r8         ; Set P=R8 as program counter
    idl            ; Idle or wait for interrupt or DMA request
    shlc           ; Shift left with carry
compiler:       ;hrj could be error?
    sep r8         ; Set P=R8 as program counter
    idl            ; Idle or wait for interrupt or DMA request
    glo r0         ; Get low register R0
datasize:
    sep r4         ; Set P=R4 as program counter
    ldn r4         ; Load D with (R4)
    phi rb         ; Put high register RB
    ldn r5         ; Load D with (R5)
    inc r8         ; Increment (R8)
    ldn r4         ; Load D with (R4)
    plo r4         ; Put low register R4
    ldn r4         ; Load D with (R4)
    sex re         ; Set P=RE as datapointer
    ldn r3         ; Load D with (R3)
    db $38, $01        ; Skip next byte
    dec rc         ; Decrement (RC)
dinc:
    sep r4         ; Set P=R4 as program counter
    idl            ; Idle or wait for interrupt or DMA request
    ldn r1         ; Load D with (R1)
    idl            ; Idle or wait for interrupt or DMA request
    idl            ; Idle or wait for interrupt or DMA request
    ldn r2         ; Load D with (R2)
    sex re         ; Set P=RE as datapointer
    ldn r1         ; Load D with (R1)
    dec rc         ; Decrement (RC)
erase:
    sep r4         ; Set P=R4 as program counter
    ldn r5         ; Load D with (R5)
    out 4          ; Output (R(X)); Increment R(X), N=100
    ldn r4         ; Load D with (R4)
    plo r4         ; Put low register R4
    ldn r3         ; Load D with (R3)
    glo r4         ; Get low register R4
    ldn r1         ; Load D with (R1)
    or             ; Logical OR  D with (R(X))
    ldn r9         ; Load D with (R9)
    inc r4         ; Increment (R4)
    ldn r7         ; Load D with (R7)
    lda r4         ; Load D from (R4), increment R4
    ldn r4         ; Load D with (R4)
    plo r4         ; Put low register R4
    ldn r5         ; Load D with (R5)
    inc rb         ; Increment (RB)
    ldn r4         ; Load D with (R4)
    phi r0         ; Put high register R0
    ldn r8         ; Load D with (R8)
    sex r8         ; Set P=R8 as datapointer
    ldn r7         ; Load D with (R7)
    lda r4         ; Load D from (R4), increment R4
    ldn r5         ; Load D with (R5)
    inc r8         ; Increment (R8)
    ldn r4         ; Load D with (R4)
    phi r0         ; Put high register R0
    ldn r8         ; Load D with (R8)
    sex r8         ; Set P=R8 as datapointer
    ldn r5         ; Load D with (R5)
    out 4          ; Output (R(X)); Increment R(X), N=100
    ldn r4         ; Load D with (R4)
    phi r0         ; Put high register R0
    ldn r1         ; Load D with (R1)
    ldn re         ; Load D with (RE)
    ldn r7         ; Load D with (R7)
    sep rb         ; Set P=RB as program counter
    ldn r1         ; Load D with (R1)
    ldn re         ; Load D with (RE)
forget:
    sep r4         ; Set P=R4 as program counter
    ldn r7         ; Load D with (R7)
    ghi rc         ; Get high register RC
    ldn r3         ; Load D with (R3)
    ldn re         ; Load D with (RE)
    ldn r5         ; Load D with (R5)
    dec r0         ; Decrement (R0)
    lda rf         ; Load D from (RF), increment RF
    lda rb         ; Load D from (RB), increment RB
    ldn rd         ; Load D with (RD)
    ldn ra         ; Load D with (RA)
    ldn r5         ; Load D with (R5)
    lda r2         ; Load D from (R2), increment R2
    ldn r2         ; Load D with (R2)
    shl            ; Shift left D
    ldn r8         ; Load D with (R8)
    or             ; Logical OR  D with (R(X))
create:
    sep r4         ; Set P=R4 as program counter
    ldn r8         ; Load D with (R8)
    sep rb         ; Set P=RB as program counter
    ldn r7         ; Load D with (R7)
    lda r4         ; Load D from (R4), increment R4
    ldn r8         ; Load D with (R8)
    lsdf           ; Long skip on DF=1
    ldn r4         ; Load D with (R4)
    phi r0         ; Put high register R0
    ldn r4         ; Load D with (R4)
    lsnf           ; Long skip on DF=0
    ldn r5         ; Load D with (R5)
    inc rb         ; Increment (RB)
    ldn r4         ; Load D with (R4)
    plo r4         ; Put low register R4
    ldn r7         ; Load D with (R7)
    ghi rc         ; Get high register RC
    ldn r4         ; Load D with (R4)
    phi rb         ; Put high register RB
    ldn r7         ; Load D with (R7)
    lda r4         ; Load D from (R4), increment R4
    ldn r5         ; Load D with (R5)
    inc r8         ; Increment (R8)
    ldn r4         ; Load D with (R4)
    phi r0         ; Put high register R0
    ldn r8         ; Load D with (R8)
    sex r8         ; Set P=R8 as datapointer
    ldn r5         ; Load D with (R5)
    out 4          ; Output (R(X)); Increment R(X), N=100
    ldn r4         ; Load D with (R4)
    phi r0         ; Put high register R0
    ldn r8         ; Load D with (R8)
    lsdf           ; Long skip on DF=1
    ldn r4         ; Load D with (R4)
    plo r4         ; Put low register R4
    ldn r5         ; Load D with (R5)
    idl            ; Idle or wait for interrupt or DMA request
    ldn r1         ; Load D with (R1)
    dec rc         ; Decrement (RC)
compile:
    sep r4         ; Set P=R4 as program counter
    ldn r2         ; Load D with (R2)
    lsnq           ; Long skip on Q=0
    ldn r1         ; Load D with (R1)
    or             ; Logical OR  D with (R(X))
    ldn r9         ; Load D with (R9)
    glo r7         ; Get low register R7
    idl            ; Idle or wait for interrupt or DMA request
    ldn r1         ; Load D with (R1)
    ldn r1         ; Load D with (R1)
    phi r2         ; Put high register R2
    ldn r4         ; Load D with (R4)
    lbz $051b       ; Long branch on D=0
    ldn r4         ; Load D with (R4)
    plo r4         ; Put low register R4
    ldn r3         ; Load D with (R3)
    db $38, $07        ; Skip next byte
    lda r4         ; Load D from (R4), increment R4
    ldn r8         ; Load D with (R8)
    lsdf           ; Long skip on DF=1
    ldn r4         ; Load D with (R4)
    phi r0         ; Put high register R0
    ldn r5         ; Load D with (R5)
    idl            ; Idle or wait for interrupt or DMA request
    idl            ; Idle or wait for interrupt or DMA request
    idl            ; Idle or wait for interrupt or DMA request
    ldn r8         ; Load D with (R8)
    lsdf           ; Long skip on DF=1
    ldn r4         ; Load D with (R4)
    plo r4         ; Put low register R4
    ldn r8         ; Load D with (R8)
    sex r8         ; Set P=R8 as datapointer
    ldn r4         ; Load D with (R4)
    lsnf           ; Long skip on DF=0
    ldn r5         ; Load D with (R5)
    inc rb         ; Increment (RB)
    ldn r4         ; Load D with (R4)
    plo r4         ; Put low register R4
    ldn r2         ; Load D with (R2)
    dec r6         ; Decrement (R6)
    ldn r5         ; Load D with (R5)
    inc rb         ; Increment (RB)
    ldn r4         ; Load D with (R4)
    plo r4         ; Put low register R4
    ldn r8         ; Load D with (R8)
    sex r8         ; Set P=R8 as datapointer
    ldn r5         ; Load D with (R5)
    inc rb         ; Increment (RB)
    ldn r4         ; Load D with (R4)
    phi r0         ; Put high register R0
    ldn r1         ; Load D with (R1)
    lbz $012c       ; Long branch on D=0
comma:
    sep r4         ; Set P=R4 as program counter
    idl            ; Idle or wait for interrupt or DMA request
    ldn r1         ; Load D with (R1)
    ldn r9         ; Load D with (R9)
    str r0         ; Store D to (R0)
    ldn r1         ; Load D with (R1)
    dec rc         ; Decrement (RC)
allot:
    sep r4         ; Set P=R4 as program counter
    ldn r2         ; Load D with (R2)
    lsnq           ; Long skip on Q=0
    ldn r1         ; Load D with (R1)
    or             ; Logical OR  D with (R(X))
    ldn r9         ; Load D with (R9)
    sex r9         ; Set P=R9 as datapointer
    ldn r8         ; Load D with (R8)
    sep rb         ; Set P=RB as program counter
    ldn r7         ; Load D with (R7)
    lda r4         ; Load D from (R4), increment R4
    ldn r8         ; Load D with (R8)
    lsdf           ; Long skip on DF=1
    ldn r4         ; Load D with (R4)
    phi r0         ; Put high register R0
    ldn r4         ; Load D with (R4)
    lsnf           ; Long skip on DF=0
    ldn r4         ; Load D with (R4)
    lbz $08cf       ; Long branch on D=0
    ldn r4         ; Load D with (R4)
    plo r4         ; Put low register R4
    ldn r3         ; Load D with (R3)
    db $38, $02        ; Skip next byte
    inc re         ; Increment (RE)
    idl            ; Idle or wait for interrupt or DMA request
    ldn r1         ; Load D with (R1)
    ldn r1         ; Load D with (R1)
    phi r2         ; Put high register R2
    idl            ; Idle or wait for interrupt or DMA request
    idl            ; Idle or wait for interrupt or DMA request
    ldn r1         ; Load D with (R1)
    lbz $0518       ; Long branch on D=0
    ldn r4         ; Load D with (R4)
    plo r4         ; Put low register R4
    ldn r8         ; Load D with (R8)
    sex r8         ; Set P=R8 as datapointer
    idl            ; Idle or wait for interrupt or DMA request
    idl            ; Idle or wait for interrupt or DMA request
    ldn r4         ; Load D with (R4)
    phi rb         ; Put high register RB
    ldn r5         ; Load D with (R5)
    inc r8         ; Increment (R8)
    ldn r4         ; Load D with (R4)
    phi r0         ; Put high register R0
    ldn r8         ; Load D with (R8)
    lsdf           ; Long skip on DF=1
    ldn r4         ; Load D with (R4)
    plo r4         ; Put low register R4
    ldn r5         ; Load D with (R5)
    inc r8         ; Increment (R8)
    ldn r4         ; Load D with (R4)
    plo r4         ; Put low register R4
    ldn r8         ; Load D with (R8)
    sex r8         ; Set P=R8 as datapointer
    ldn r7         ; Load D with (R7)
    lda r4         ; Load D from (R4), increment R4
    ldn r5         ; Load D with (R5)
    out 4          ; Output (R(X)); Increment R(X), N=100
    ldn r4         ; Load D with (R4)
    phi r0         ; Put high register R0
    ldn r5         ; Load D with (R5)
    inc r2         ; Increment (R2)
    ldn r4         ; Load D with (R4)
    plo r4         ; Put low register R4
    ldn r4         ; Load D with (R4)
    sex re         ; Set P=RE as datapointer
    idl            ; Idle or wait for interrupt or DMA request
    ldn r3         ; Load D with (R3)
    idl            ; Idle or wait for interrupt or DMA request
    idl            ; Idle or wait for interrupt or DMA request
    ldn r2         ; Load D with (R2)
    sex re         ; Set P=RE as datapointer
    ldn r3         ; Load D with (R3)
    db $38, $00        ; Skip next byte
    sep r8         ; Set P=R8 as program counter
    idl            ; Idle or wait for interrupt or DMA request
    ldn r3         ; Load D with (R3)
    ldn r9         ; Load D with (R9)
    str r0         ; Store D to (R0)
    ldn r5         ; Load D with (R5)
    idl            ; Idle or wait for interrupt or DMA request
    ldn r1         ; Load D with (R1)
    bnf  01        ; Short branch on DF=0
    dec rc         ; Decrement (RC)
varible:
    sep r4         ; Set P=R4 as program counter
    ldn r2         ; Load D with (R2)
    lsnq           ; Long skip on Q=0
    ldn r1         ; Load D with (R1)
    or             ; Logical OR  D with (R(X))
    ldn r9         ; Load D with (R9)
    shr            ; Shift right D
    ldn r9         ; Load D with (R9)
    dec r9         ; Decrement (R9)
    ldn r9         ; Load D with (R9)
    ghi r0         ; Get high register R0
    ldn r1         ; Load D with (R1)
    dec rc         ; Decrement (RC)
colon:		;HRJ may be error
    sep r4         ; Set P=R4 as program counter
;;
    ldn r9         ; Load D with (R9)
    dec r9         ; Decrement (R9)
    idl            ; Idle or wait for interrupt or DMA request
;;
    sep r4         ; Set P=R4 as program counter
    ldn r9         ; Load D with (R9)
    glo r9         ; Get low register R9
    idl            ; Idle or wait for interrupt or DMA request
    ldn r1         ; Load D with (R1)
    ldn r1         ; Load D with (R1)
    ghi rc         ; Get high register RC
    ldn r7         ; Load D with (R7)
    ghi rc         ; Get high register RC
    ldn r8         ; Load D with (R8)
    sep r8         ; Set P=R8 as program counter
    ldn r4         ; Load D with (R4)
    plo r4         ; Put low register R4
    ldn r3         ; Load D with (R3)
    glo r4         ; Get low register R4
    ldn r1         ; Load D with (R1)
    or             ; Logical OR  D with (R(X))
    ldn ra         ; Load D with (RA)
    inc r7         ; Increment (R7)
    ldn r4         ; Load D with (R4)
    plo r4         ; Put low register R4
    ldn r3         ; Load D with (R3)
    sex rd         ; Set P=RD as datapointer
    ldn r1         ; Load D with (R1)
    ldi 0a         ; Load D immediate
    lda r7         ; Load D from (R7), increment R7
    ldn r5         ; Load D with (R5)
    out 4          ; Output (R(X)); Increment R(X), N=100
    ldn r4         ; Load D with (R4)
    plo r4         ; Put low register R4
    ldn r3         ; Load D with (R3)
    glo r4         ; Get low register R4
    ldn r2         ; Load D with (R2)
    lsnq           ; Long skip on Q=0
    ldn r1         ; Load D with (R1)
    smb            ; Substract memory with borrow
    ldn r1         ; Load D with (R1)
    or             ; Logical OR  D with (R(X))
    ldn ra         ; Load D with (RA)
    dec rd         ; Decrement (RD)
    ldn r5         ; Load D with (R5)
    bdf  04        ; Short branch on DF=1
    plo r4         ; Put low register R4
    ldn r4         ; Load D with (R4)
    plo r4         ; Put low register R4
    ldn r3         ; Load D with (R3)
    glo r4         ; Get low register R4
    ldn r1         ; Load D with (R1)
    or             ; Logical OR  D with (R(X))
    ldn ra         ; Load D with (RA)
    bnf  04        ; Short branch on DF=0
    plo r4         ; Put low register R4
    idl            ; Idle or wait for interrupt or DMA request
    ldn r2         ; Load D with (R2)
    ldn r9         ; Load D with (R9)
    str r0         ; Store D to (R0)
    ldn r1         ; Load D with (R1)
    ldi 0a         ; Load D immediate
    lda r7         ; Load D from (R7), increment R7
    ldn r7         ; Load D with (R7)
    ldx            ; Pop stack. Place value in D register
    ldn r1         ; Load D with (R1)
    or             ; Logical OR  D with (R(X))
    ldn ra         ; Load D with (RA)
    lda r7         ; Load D from (R7), increment R7
    idl            ; Idle or wait for interrupt or DMA request
    idl            ; Idle or wait for interrupt or DMA request
    idl            ; Idle or wait for interrupt or DMA request
    ldn r2         ; Load D with (R2)
    ldn r9         ; Load D with (R9)
    str r0         ; Store D to (R0)
    ldn r5         ; Load D with (R5)
    ghi r5         ; Get high register R5
    ldn r1         ; Load D with (R1)
    or             ; Logical OR  D with (R(X))
    ldn ra         ; Load D with (RA)
    str r5         ; Store D to (R5)
    ldn r5         ; Load D with (R5)
    out 4          ; Output (R(X)); Increment R(X), N=100
    ldn r4         ; Load D with (R4)
    plo r4         ; Put low register R4
    ldn r3         ; Load D with (R3)
    inc ra         ; Increment (RA)
    ldn r8         ; Load D with (R8)
    or             ; Logical OR  D with (R(X))
    ldn r2         ; Load D with (R2)
    lsnq           ; Long skip on Q=0
    ldn r1         ; Load D with (R1)
    smb            ; Substract memory with borrow
    ldn r1         ; Load D with (R1)
    plo r3         ; Put low register R3
    ldn r1         ; Load D with (R1)
    dec rc         ; Decrement (RC)
vlisthrj:
    sep r4         ; Set P=R4 as program counter
    ldn r5         ; Load D with (R5)
    out 4          ; Output (R(X)); Increment R(X), N=100
    ldn r4         ; Load D with (R4)
    plo r4         ; Put low register R4
    ldn r1         ; Load D with (R1)
    ghi rc         ; Get high register RC
    ldn r7         ; Load D with (R7)
    lda r4         ; Load D from (R4), increment R4
    ldn r2         ; Load D with (R2)
    inc re         ; Increment (RE)
    ldn r1         ; Load D with (R1)
    or             ; Logical OR  D with (R(X))
    ldn ra         ; Load D with (RA)
    glo r6         ; Get low register R6
    ldn r7         ; Load D with (R7)
    lda r4         ; Load D from (R4), increment R4
    ldn r3         ; Load D with (R3)
    inc ra         ; Increment (RA)
    ldn r5         ; Load D with (R5)
    req            ; Reset Q=0
    ldn r5         ; Load D with (R5)
    glo rb         ; Get low register RB
    ldn r7         ; Load D with (R7)
    lda r4         ; Load D from (R4), increment R4
    ldn r2         ; Load D with (R2)
    inc re         ; Increment (RE)
    idl            ; Idle or wait for interrupt or DMA request
    idl            ; Idle or wait for interrupt or DMA request
    ldn r2         ; Load D with (R2)
    sex re         ; Set P=RE as datapointer
    idl            ; Idle or wait for interrupt or DMA request
    ldn r3         ; Load D with (R3)
    idl            ; Idle or wait for interrupt or DMA request
    idl            ; Idle or wait for interrupt or DMA request
    ldn r2         ; Load D with (R2)
;;
    sex re         ; Set P=RE as datapointer
    ldn r1         ; Load D with (R1)
    ldi $0a         ; Load D immediate
    glo ra         ; Get low register RA
    ldn r8         ; Load D with (R8)
    sex r8         ; Set P=R8 as datapointer
    ldn r4         ; Load D with (R4)
    plo r4         ; Put low register R4
    ldn r7         ; Load D with (R7)
    lda r4         ; Load D from (R4), increment R4
    ldn r1         ; Load D with (R1)
    inp 5          ; Input to (R(X)) and D, N=101
    ldn r1         ; Load D with (R1)
    smb            ; Substract memory with borrow
    ldn r1         ; Load D with (R1)
    plo r3         ; Put low register R3
    ldn r1         ; Load D with (R1)
    db $38, $01        ; Skip next byte
    dec rc         ; Decrement (RC)
semicoln:
    sep r4         ; Set P=R4 as program counter
    ldn r1         ; Load D with (R1)
    bdf  00        ; Short branch on DF=1
    ldn r1         ; Load D with (R1)
    ldn r1         ; Load D with (R1)
    glo r0         ; Get low register R0
    ldn r1         ; Load D with (R1)
    or             ; Logical OR  D with (R(X))
    ldn ra         ; Load D with (RA)
    plo rf         ; Put low register RF
    ldn r1         ; Load D with (R1)
    bnf  00        ; Short branch on DF=0
    dec rc         ; Decrement (RC)
    idl            ; Idle or wait for interrupt or DMA request
    ldn r1         ; Load D with (R1)
    idl            ; Idle or wait for interrupt or DMA request
    ldn r2         ; Load D with (R2)
    ldn r9         ; Load D with (R9)
    str r0         ; Store D to (R0)
    idl            ; Idle or wait for interrupt or DMA request
    idl            ; Idle or wait for interrupt or DMA request
    ldn r1         ; Load D with (R1)
    dec rc         ; Decrement (RC)
    ldn r3         ; Load D with (R3)
    ldn re         ; Load D with (RE)
    ldn r1         ; Load D with (R1)
    bnf  07        ; Short branch on DF=0
    sep rb         ; Set P=RB as program counter
    ldn r1         ; Load D with (R1)
    dec rc         ; Decrement (RC)
quote1:
    sep r4         ; Set P=R4 as program counter
    idl            ; Idle or wait for interrupt or DMA request
    ldn re         ; Load D with (RE)
    idl            ; Idle or wait for interrupt or DMA request
    ldn r3         ; Load D with (R3)
    idl            ; Idle or wait for interrupt or DMA request
    ldn r2         ; Load D with (R2)
    ldn r9         ; Load D with (R9)
    str r0         ; Store D to (R0)
    ldn r8         ; Load D with (R8)
    lsnz           ; Long skip on D!=0
    ldn r1         ; Load D with (R1)
    bdf  00        ; Short branch on DF=1
    ldn r1         ; Load D with (R1)
    ldn r1         ; Load D with (R1)
    str re         ; Store D to (RE)
    ldn r9         ; Load D with (R9)
    str r0         ; Store D to (R0)
    ldn r1         ; Load D with (R1)
    dec rc         ; Decrement (RC)
if:
    sep r4         ; Set P=R4 as program counter
    idl            ; Idle or wait for interrupt or DMA request
    idl            ; Idle or wait for interrupt or DMA request
    idl            ; Idle or wait for interrupt or DMA request
    idl            ; Idle or wait for interrupt or DMA request
    idl            ; Idle or wait for interrupt or DMA request
    or             ; Logical OR  D with (R(X))
    idl            ; Idle or wait for interrupt or DMA request
    ldn r1         ; Load D with (R1)
    idl            ; Idle or wait for interrupt or DMA request
    ldn r4         ; Load D with (R4)
    ldn r9         ; Load D with (R9)
    str r0         ; Store D to (R0)
    ldn r5         ; Load D with (R5)
    inc rb         ; Increment (RB)
    ldn r4         ; Load D with (R4)
    plo r4         ; Put low register R4
    idl            ; Idle or wait for interrupt or DMA request
    ldn r2         ; Load D with (R2)
    idl            ; Idle or wait for interrupt or DMA request
    idl            ; Idle or wait for interrupt or DMA request
    ldn r3         ; Load D with (R3)
    db $38, $00        ; Skip next byte
    ldn r2         ; Load D with (R2)
    ldn r1         ; Load D with (R1)
    dec rc         ; Decrement (RC)
else:
    sep r4         ; Set P=R4 as program counter
    ldn r1         ; Load D with (R1)
    bdf  00        ; Short branch on DF=1
    ldn r2         ; Load D with (R2)
    ldn r1         ; Load D with (R1)
    glo r0         ; Get low register R0
    ldn r1         ; Load D with (R1)
    or             ; Logical OR  D with (R(X))
    ldn rb         ; Load D with (RB)
    inc rc         ; Increment (RC)
    ldn r1         ; Load D with (R1)
    bnf  05        ; Short branch on DF=0
    inc rb         ; Increment (RB)
    ldn r4         ; Load D with (R4)
    plo r4         ; Put low register R4
    idl            ; Idle or wait for interrupt or DMA request
    ldn r4         ; Load D with (R4)
    idl            ; Idle or wait for interrupt or DMA request
    idl            ; Idle or wait for interrupt or DMA request
    ldn r2         ; Load D with (R2)
    sex re         ; Set P=RE as datapointer
    ldn r4         ; Load D with (R4)
    sex re         ; Set P=RE as datapointer
    ldn r4         ; Load D with (R4)
    phi r0         ; Put high register R0
    idl            ; Idle or wait for interrupt or DMA request
    idl            ; Idle or wait for interrupt or DMA request
    idl            ; Idle or wait for interrupt or DMA request
    idl            ; Idle or wait for interrupt or DMA request
    idl            ; Idle or wait for interrupt or DMA request
    ldi 00         ; Load D immediate
    ldn r1         ; Load D with (R1)
    idl            ; Idle or wait for interrupt or DMA request
    ldn r4         ; Load D with (R4)
    ldn r9         ; Load D with (R9)
    str r0         ; Store D to (R0)
    ldn r5         ; Load D with (R5)
    inc rb         ; Increment (RB)
    ldn r4         ; Load D with (R4)
    plo r4         ; Put low register R4
    idl            ; Idle or wait for interrupt or DMA request
    ldn r2         ; Load D with (R2)
    idl            ; Idle or wait for interrupt or DMA request
    idl            ; Idle or wait for interrupt or DMA request
    ldn r3         ; Load D with (R3)
    db $38, $00        ; Skip next byte
    ldn r3         ; Load D with (R3)
    ldn r1         ; Load D with (R1)
    dec rc         ; Decrement (RC)
    ldn r3         ; Load D with (R3)
    ldn re         ; Load D with (RE)
    ldn r4         ; Load D with (R4)
    lda r5         ; Load D from (R5), increment R5
    lda rc         ; Load D from (RC), increment RC
    str r3         ; Store D to (R3)
    lda r5         ; Load D from (R5), increment R5
    ldn r7         ; Load D with (R7)
    sep rb         ; Set P=RB as program counter
    ldn r1         ; Load D with (R1)
    dec rc         ; Decrement (RC)
endif:
    sep r4         ; Set P=R4 as program counter
    ldn r1         ; Load D with (R1)
    bdf  01        ; Short branch on DF=1
    bdf  00        ; Short branch on DF=1
    ldn r2         ; Load D with (R2)
    ldn r1         ; Load D with (R1)
    glo r0         ; Get low register R0
    ldn r1         ; Load D with (R1)
    smb            ; Substract memory with borrow
    ldn r1         ; Load D with (R1)
    or             ; Logical OR  D with (R(X))
    ldn rb         ; Load D with (RB)
    str r2         ; Store D to (R2)
    idl            ; Idle or wait for interrupt or DMA request
    ldn r3         ; Load D with (R3)
    ldn r1         ; Load D with (R1)
    glo r0         ; Get low register R0
    ldn r1         ; Load D with (R1)
    smb            ; Substract memory with borrow
    ldn r1         ; Load D with (R1)
    or             ; Logical OR  D with (R(X))
    ldn rb         ; Load D with (RB)
    lda rc         ; Load D from (RC), increment RC
    ldn r3         ; Load D with (R3)
    ldn re         ; Load D with (RE)
    ldn r5         ; Load D with (R5)
    lda r5         ; Load D from (R5), increment R5
    lda re         ; Load D from (RE), increment RE
    lda r4         ; Load D from (R4), increment R4
    lda r9         ; Load D from (R9), increment R9
    lda r6         ; Load D from (R6), increment R6
    ldn r7         ; Load D with (R7)
    sep rb         ; Set P=RB as program counter
    ldn r1         ; Load D with (R1)
    dec rc         ; Decrement (RC)
    ldn r1         ; Load D with (R1)
    bnf  01        ; Short branch on DF=0
    ldi 0b         ; Load D immediate
    str r4         ; Store D to (R4)
    ldn r1         ; Load D with (R1)
    db $38, $05        ; Skip next byte
    inc rb         ; Increment (RB)
    ldn r4         ; Load D with (R4)
    plo r4         ; Put low register R4
    ldn r4         ; Load D with (R4)
    sex re         ; Set P=RE as datapointer
    ldn r4         ; Load D with (R4)
    phi r0         ; Put high register R0
    ldn r1         ; Load D with (R1)
    dec rc         ; Decrement (RC)
do1:
    sep r4         ; Set P=R4 as program counter
    idl            ; Idle or wait for interrupt or DMA request
    phi r2         ; Put high register R2
    idl            ; Idle or wait for interrupt or DMA request
    ldn r1         ; Load D with (R1)
    idl            ; Idle or wait for interrupt or DMA request
    ldn r2         ; Load D with (R2)
    ldn r9         ; Load D with (R9)
    str r0         ; Store D to (R0)
    idl            ; Idle or wait for interrupt or DMA request
    ldn r4         ; Load D with (R4)
    ldn r1         ; Load D with (R1)
    dec rc         ; Decrement (RC)
loop1:
    sep r4         ; Set P=R4 as program counter
    ldn r1         ; Load D with (R1)
    bdf  00        ; Short branch on DF=1
    ldn r4         ; Load D with (R4)
    ldn r1         ; Load D with (R1)
    glo r0         ; Get low register R0
    ldn r1         ; Load D with (R1)
    or             ; Logical OR  D with (R(X))
    ldn rb         ; Load D with (RB)
    glo r2         ; Get low register R2
    ldn r1         ; Load D with (R1)
    bnf  00        ; Short branch on DF=0
    lbz $0001       ; Long branch on D=0
    idl            ; Idle or wait for interrupt or DMA request
    ldn r2         ; Load D with (R2)
    ldn r9         ; Load D with (R9)
    str r0         ; Store D to (R0)
    ldn r1         ; Load D with (R1)
    dec rc         ; Decrement (RC)
    ldn r3         ; Load D with (R3)
    ldn re         ; Load D with (RE)
;;
    db 04,'LOOP'
;;
    dw wordq
    dw return

pluslp1:
    sep r4         ; Set P=R4 as program counter
    ldn r1         ; Load D with (R1)
    bdf  00        ; Short branch on DF=1
    ldn r4         ; Load D with (R4)
    ldn r1         ; Load D with (R1)
    glo r0         ; Get low register R0
    ldn r1         ; Load D with (R1)
    or             ; Logical OR  D with (R(X))
    ldn rb         ; Load D with (RB)
    plo r4         ; Put low register R4
    ldn r1         ; Load D with (R1)
    bnf  00        ; Short branch on DF=0
    lsnq           ; Long skip on Q=0
    idl            ; Idle or wait for interrupt or DMA request
    ldn r1         ; Load D with (R1)
    idl            ; Idle or wait for interrupt or DMA request
    ldn r2         ; Load D with (R2)
    ldn r9         ; Load D with (R9)
    str r0         ; Store D to (R0)
    ldn r1         ; Load D with (R1)
    dec rc         ; Decrement (RC)
    ldn r3         ; Load D with (R3)
    ldn re         ; Load D with (RE)
;;
    ;ascii
    db 05,'+LOOP'
;;
    dw wordq
    dw return

repeat1:
    sep r4         ; Set P=R4 as program counter
    idl            ; Idle or wait for interrupt or DMA request
    ghi rc         ; Get high register RC
    idl            ; Idle or wait for interrupt or DMA request
    ldn r1         ; Load D with (R1)
    idl            ; Idle or wait for interrupt or DMA request
    ldn r2         ; Load D with (R2)
    ldn r9         ; Load D with (R9)
    str r0         ; Store D to (R0)
    idl            ; Idle or wait for interrupt or DMA request
    ldn r5         ; Load D with (R5)
    ldn r1         ; Load D with (R1)
    dec rc         ; Decrement (RC)
until1:
    sep r4         ; Set P=R4 as program counter
    ldn r1         ; Load D with (R1)
    bdf  00        ; Short branch on DF=1
    ldn r5         ; Load D with (R5)
    ldn r1         ; Load D with (R1)
    glo r0         ; Get low register R0
    ldn r1         ; Load D with (R1)
    or             ; Logical OR  D with (R(X))
    ldn rb         ; Load D with (RB)
;;
    sep r4         ; Set P=R4 as program counter
    ldn r1         ; Load D with (R1)
    bnf  00        ; Short branch on DF=0
    plo r3         ; Put low register R3
    idl            ; Idle or wait for interrupt or DMA request
    ldn r1         ; Load D with (R1)
    idl            ; Idle or wait for interrupt or DMA request
    ldn r2         ; Load D with (R2)
    ldn r9         ; Load D with (R9)
    str r0         ; Store D to (R0)
    ldn r1         ; Load D with (R1)
    dec rc         ; Decrement (RC)
    ldn r3         ; Load D with (R3)
    ldn re         ; Load D with (RE)
 ;;
 ;; not sure what this stuff is....
 ;;;;                        
    db 5,'UNTIL'
    ldn r7         ; Load D with (R7)
    sep rb         ; Set P=RB as program counter
;;
    ldn r1         ; Load D with (R1)
    dec rc         ; Decrement (RC)
abort2:
    sep r4         ; Set P=R4 as program counter
    ldn r5         ; Load D with (R5)
    out 4          ; Output (R(X)); Increment R(X), N=100
    ldn r4         ; Load D with (R4)
    plo r4         ; Put low register R4
    ldn r3         ; Load D with (R3)
    inc ra         ; Increment (RA)
    ldn r8         ; Load D with (R8)
    or             ; Logical OR  D with (R(X))
    ldn r1         ; Load D with (R1)
    dec rc         ; Decrement (RC)
;;
 ;--------------------------------------
 ;	     Dictionary
 ;	Names and Addresses
 ;--------------------------------------
;--------------------------------------
;	 8th V1.2    Dictionary
;	Names and Addresses
;--------------------------------------
;
; This part of the dictionary contains
; all the words initially part of 8TH
; following "clear" or a hardware clear.
; Each entry consists of the word itself
; (in string format: length byte first)
; followed by the address where the
; executable code for the word is
; located.  Entries and deletions are
; made at the low-address end.  The
; last entry is always 0 (null string)
; followed by address=0000.
;
	org 0bebh
;
vcomp:	equ  $		; compiler vocab
	db 5,'ABORT'
	dw abort2
	
	db 5,'UNTIL'
	dw until1

	db 6,'REPEAT'
	dw repeat1
	
	db 5,'+LOOP'
	dw pluslp1

	db 4,'LOOP'
	dw loop1

	db 2,'DO'
	dw do1

	db 5,'ENDIF'
	dw endif

	db 4,'ELSE'
	dw else

	db 2,'IF'
	dw if

	db 1,'"'
	dw quote1

	db 1,'('
	dw openparen

	db 1,';'
	dw semicoln
	
	db 0
	dw 0
	
v8th:	equ $		; 8TH vocab

	db 5,'VLIST'
	dw beatsme

	db 1,':'
	dw colon

	db 8,'VARIABLE'
	dw varible

	db 5,'ALLOT'
	dw allot

	db 1,','
	dw comma

	db 7,'COMPILE'
	dw compile

	db 6,'CREATE'
	dw create

	db 6,'FORGET'
	dw forget

	db 3,'ERA'	;ERASE
	dw erase

	db 3,'D1+'
	dw dinc

	db 5,'DS'	;DSIZE
	dw datasize

	db 8,'COMPILER'
	dw compiler

	db 3,'8TH'
	dw eighth

	db 4,'USER'
	dw user

	db 2,'SZ'	;SIZE
	dw size

	db 1,'"'
	dw quote

	db 1,'('
	dw openparen

	db 2,'BS'
	dw backspce

	db 3,'CAN'
	dw cancel

	db 3,'HEX'
	dw hex

	db 7,'DECIMAL'
	dw decimal

	db 1,'.'
	dw dot

	db 2,'D.'
	dw ddot

	db 9,'INTERPRET'
	dw intrpret

      db 1,"'"
	dw tick

	db 2,'N?'	;NUMBER?
	dw numberq

	db 2,'W?'	;WORD?
	dw wordq

	db 7,'GETWORD'
	dw getword

	db 1,'#'
	dw tonumber

	db 4,'DDUP'
	dw ddup

	db 6,'NUMBER'
	dw number

	db 7,'DNUMBER'
	dw dnumber

	db 6,'EXPECT'
	dw expect

	db 7,'GETAKEY'
	dw getakey

	db 5,'CHECK'
	dw check

	db 6,'M?'	;MEMFUL
	dw memful

	db 2,'CR'
	dw cr

	db 4,'TYPE'
	dw type

	db 4,'EMIT'
	dw emit

	db 6,'OUTPUT'
	dw output

	db 5,'INPUT'
	dw input

	db 2,'C@'	;CURNT@
	dw curntat

	db 2,'B@'	;BASE@
	dw basat

	db 2,'$A'	;$ABORT
	dw stabort

	db 2,'#L' 	;'LASTKEY#' 
	dw lastkeyn

	db 4,'BAUD'
	dw baud

	db 2,'#C'	;#CYCLES
	dw nocycles

	db 4,'ECHO'
	dw echo1

	db 4,'CAPS'
	dw caps

	db 6,'BUFFER'
	dw buffer

	db 9,'DELIMITER'
	dw delmiter

	db 10,'TERMINATOR'
	dw termnatr

	db 4,'BASE'
	dw base

	db 1,'N'
	dw n

	db 7,'CONTEXT'
	dw context

	db 7,'CURRENT'
	dw current

	db 3,'DMA'
	dw dma2

	db 3,'VAT'
	dw vat

	db 9,'INTERRUPT'
	dw intrupt1

	db 4,'CALL'
	dw call2

	db 4,'NEXT'
	dw next2

	db 3,'1ST'
	dw first

	db 4,'RSP0'
	dw rsp0

	db 3,'SP0'
	dw sp0

	db 6,'MINRAM'
	dw minram

	db 6,'MAXRAM'
	dw maxram

	db 3,'R>D'
	dw rtnmove

	db 5,'DSWAP'
	dw dswap

	db 2,'D<'
	dw dless

	db 3,'D>R'
	dw datamove

	db 4,'RSP@'
	dw rspat

	db 3,'SP@'
	dw spat

	db 2,'D!'
	dw dwri

	db 2,'D@'
	dw dat

	db 1,'/'
	dw divide

      db 2,"+'"
	dw addc

	db 5,'DIGIT'
	dw digit

	db 4,'$DUP'
	dw stdup

        db 2,"*'"
	dw multc

	db 1,'*'
	dw mult

	db 7,'EXECUTE'
	dw execute

	db 2,'LF'
	dw lf

	db 5,'DOVER'
	dw dover

	db 4,'FIND'
	dw find

	db 4,'WORD'
	dw word

	db 2,'D-'
	dw dsub

	db 5,'$DROP'
	dw stdr

	db 2,'$@'
	dw stat

	db 2,'$L'
	dw stlod

	db 2,'$!'
	dw stwri

	db 2,'D+'
	dw dadd

	db 6,'APPEND'
	dw append

	db 5,'DUPNZ'
	dw dupnz

	db 4,'DMA!'
	dw dmawri

	db 2,'Q!'
	dw qwri

	db 4,'KEYS'
	dw keys

	db 5,'EMITS'
	dw emits

	db 2,'V@'
	dw varat

	db 1,'!'
	dw excla

	db 1,'@'
	dw at

	db 3,'IE@'
	dw ieat

	db 2,'IE'
	dw ie

	db 4,'EXIT'
	dw exit

	db 1,'I'
	dw i

	db 1,'<'
	dw less

	db 1,'>'
	dw greater

	db 1,'='
	dw equal

	db 3,'NOT'
	dw not1

	db 3,'XOR'
	dw xor1

	db 2,'OR'
	dw or1

	db 3,'AND'
	dw and1

	db 1,'-'
	dw subtr

	db 1,'+'
	dw add

	db 3,'ROT'
	dw rot

	db 4,'SWAP'
	dw swap

	db 4,'OVER'
	dw over

	db 4,'DROP'
	dw drop

	db 5,'DDROP'
	dw ddrop

	db 3,'DUP'
	dw dup

	db 6,'RETURN'
	dw return

        db 7,"'ABORT'"
	dw abort

	db 5,'ABORT'
	dw abort

	db 5,'RESET'
	dw reset

	db 5,'CLEAR'
	dw clear

; words from V1.0 not in V1.2
;	db 2,'BR'
;	dw br
;
;	db 3,'BR0'
;	dw br0
;
;      db 7,'(+LOOP)'
;	dw pluslp
;
;       db 6,'(LOOP)'
;	dw loop
;
;       db 4,'(DO)'
;	dw do
;
;       db 7,'(UNTIL)'
;	dw until
;
;       db 8,'(REPEAT)'
;	dw repeat
;
;	db 3,'CLR'
;	dw clr
; end of words not in V1.2

	db 0
	dw 0		; end of 8th vocab
;;
    ;  inittable & endinit:
    ;
    idl            ; Idle or wait for interrupt or DMA request
    idl            ; Idle or wait for interrupt or DMA request
    idl            ; Idle or wait for interrupt or DMA request
    ldn rb         ; Load D with (RB)
    sex rb         ; Set P=RB as datapointer
    ldn rc         ; Load D with (RC)
    bnf  00        ; Short branch on DF=0
    idl            ; Idle or wait for interrupt or DMA request
    idl            ; Idle or wait for interrupt or DMA request
    idl            ; Idle or wait for interrupt or DMA request
    ldn r8         ; Load D with (R8)
    inc r8         ; Increment (R8)
    ldn r2         ; Load D with (R2)
    dec re         ; Decrement (RE)
    ldn r2         ; Load D with (R2)
    str rd         ; Store D to (RD)
    idl            ; Idle or wait for interrupt or DMA request
    out 2          ; Output (R(X)); Increment R(X), N=010
    smi 01         ; Substract D,DF to value
    ldn r1         ; Load D with (R1)
bufr:
    db 79		; buffer
    db 13,10	; sign-on message
    db '    8TH, REVISION 1.2',13,10
    db '    COPYRIGHT 1982 BY',13,10
    db 'TECHNICAL MICRO SYSTEMS, INC'
    db '.', 13, 10
;;
    ;data
    smi $20         ; Substract D,DF to value
    ldn rd         ; Load D with (RD)
    ldn ra         ; Load D with (RA)
    idl            ; Idle or wait for interrupt or DMA request
    idl            ; Idle or wait for interrupt or DMA request
    smi $ff         ; Substract D,DF to value
    smi $ff         ; Substract D,DF to value
    smi $ff         ; Substract D,DF to value
    ldn r2         ; Load D with (R2)
    inc r1         ; Increment (R1)
    idl            ; Idle or wait for interrupt or DMA request
    xri $00         ; Logical XOR D with value
    sex re         ; Set P=RE as datapointer
    idl            ; Idle or wait for interrupt or DMA request
    sex r6         ; Set P=R6 as datapointer
    ldn r8         ; Load D with (R8)
    dec rc         ; Decrement (RC)
    inc r0         ; Increment (R0)
    idl            ; Idle or wait for interrupt or DMA request
    bn4  $7b        ; Short branch on EF4=0
    inc r0         ; Increment (R0)
    idl            ; Idle or wait for interrupt or DMA request
    bn4  $ff        ; Short branch on EF4=0
;;
    end

